(set-info :smt-lib-version 2.6)
;;; Processed by pysmt to remove constant-real bitvector literals
(set-logic QF_FP)
(set-info :source |SPARK inspired floating point problems by Florian Schanda and Martin Brain|)
(set-info :category "crafted")
(set-option :produce-models true)
(define-fun is_finite ((f Float32)) Bool (or (fp.isZero f) (fp.isNormal f) (fp.isSubnormal f)))
(declare-fun a () Float32)
(declare-fun b () Float32)
(declare-fun c () Float32)
(assert (is_finite a))
(assert (is_finite b))
(assert (is_finite c))
(assert (is_finite (fp.add RNE a b)))
(assert (is_finite (fp.add RNE b c)))
(assert (is_finite (fp.add RNE a (fp.add RNE b c))))
(assert (is_finite (fp.add RNE (fp.add RNE a b) c)))
(assert (not (fp.eq (fp.add RNE a (fp.add RNE b c)) (fp.add RNE (fp.add RNE a b) c))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 32)) (y (_ BitVec 32))) (_ BitVec 32)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 32))
(declare-fun my_new_bv_goal () (_ BitVec 34))
; constraints
(assert (= ((_ to_fp 8 24) my_new_bv_support) c))
(assert (=> (= #b1 ((_ extract 33 33) my_new_bv_goal)) (not (fp.isNaN c))))
(assert (=> (= #b1 ((_ extract 32 32) my_new_bv_goal)) (fp.isPositive c))))
(assert (=  ((_ extract 31 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b11 ((_ extract 33 32) my_new_bv_goal)) #b01111111111111111111111111111111
                     (ite (= #b10 ((_ extract 33 32) my_new_bv_goal)) #b10000000000000000000000000000000
                                                                          #b00000000000000000000000000000000
            )))
))
(maximize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (c))
(get-objectives)

(get-model)
(exit)
