(set-info :smt-lib-version 2.6)
;;; Processed by pysmt to remove constant-real bitvector literals
(set-logic QF_FP)
(set-info :source |SPARK inspired floating point problems by Florian Schanda|)
(set-info :category "crafted")
(set-option :produce-models true)
(define-fun is_spark_float ((f Float32)) Bool (not (or (fp.isNaN f) (fp.isInfinite f))))
(define-fun float__last () Float32 ((_ to_fp 8 24) #x7F7FFFFF))
(declare-fun x () Float32)
(declare-fun y () Float32)
(assert (is_spark_float x))
(assert (is_spark_float y))
(assert (fp.geq x (_ +zero 8 24)))
(assert (fp.geq y (_ +zero 8 24)))
(assert (not (fp.eq y (_ +zero 8 24))))
(assert (not (fp.lt y (fp.div RNE x float__last))))
(assert (not (is_spark_float (fp.div RNE x y))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 32)) (y (_ BitVec 32))) (_ BitVec 32)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 32))
(declare-fun my_new_bv_goal () (_ BitVec 34))
; constraints
(assert (= ((_ to_fp 8 24) my_new_bv_support) x))
(assert (=> (= #b1 ((_ extract 33 33) my_new_bv_goal)) (not (fp.isNaN x))))
(assert (=> (= #b1 ((_ extract 32 32) my_new_bv_goal)) (fp.isPositive x))))
(assert (=  ((_ extract 31 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b11 ((_ extract 33 32) my_new_bv_goal)) #b01111111111111111111111111111111
                     (ite (= #b10 ((_ extract 33 32) my_new_bv_goal)) #b10000000000000000000000000000000
                                                                          #b00000000000000000000000000000000
            )))
))
(maximize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (x))
(get-objectives)

(get-model)
(exit)
