(set-info :smt-lib-version 2.6)
;;; Processed by pysmt to remove constant-real bitvector literals
(set-logic QF_FP)
(set-info :source |SPARK inspired floating point problems by Florian Schanda|)
(set-info :category "crafted")
(set-option :produce-models true)
(define-fun isFinite ((f Float32)) Bool (or (fp.isNormal f) (fp.isSubnormal f) (fp.isZero f)))
(define-fun float__last () Float32 ((_ to_fp 8 24) #x7F7FFFFF))
(define-fun f0 () Float32 (_ +zero 8 24))
(define-fun f1 () Float32 ((_ to_fp 8 24) #x3f800000))
(declare-fun left () Float32)
(declare-fun right () Float32)
(assert (isFinite left))
(assert (isFinite right))
(assert (fp.geq left f0))
(assert (fp.geq right f0))
(define-fun result_1 () Float32 (fp.div RNE left right))
(define-fun result_2 () Float32 (ite (fp.eq right f0) float__last (ite (fp.lt right (fp.div RNE left float__last)) float__last result_1)))
(define-fun result_3 () Float32 (ite (fp.lt right f1) result_2 result_1))
(assert (not (isFinite result_3)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 32)) (y (_ BitVec 32))) (_ BitVec 32)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
(define-fun _bv_nxor ((x (_ BitVec 32)) (y (_ BitVec 32))) (_ BitVec 32)

    (bvand (bvor x y) (bvor (bvnot x) (bvnot y)))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 32))
(declare-fun my_new_bv_goal () (_ BitVec 34))
; constraints
(assert (= ((_ to_fp 8 24) my_new_bv_support) left))

(assert (=> (= #b0 ((_ extract 33 33) my_new_bv_goal)) (not (fp.isNaN left))))
(assert (=> (= #b0 ((_ extract 32 32) my_new_bv_goal)) (fp.isNegative left))))
(assert (=  ((_ extract 31 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b00 ((_ extract 33 32) my_new_bv_goal)) #b11111111111111111111111111111111
                     (ite (= #b01 ((_ extract 33 32) my_new_bv_goal)) #b00000000000000000000000000000000
                                                                          #b00000000000000000000000000000000
            )))
))
(minimize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (left))
(get-objectives)

(get-model)
(exit)
