(set-info :smt-lib-version 2.6)
;;; Processed by pysmt to remove constant-real bitvector literals
(set-logic QF_FP)
(set-info :source |SPARK inspired floating point problems by Florian Schanda and Martin Brain|)
(set-info :category "crafted")
(set-option :produce-models true)
(define-fun is_finite ((f Float32)) Bool (or (fp.isNormal f) (fp.isZero f) (fp.isSubnormal f)))
(declare-fun a () Float32)
(assert (is_finite a))
(assert (fp.isPositive a))
(define-fun scale () Float32 ((_ to_fp 8 24) #x3f400000))
(assert (not (fp.lt (fp.mul RNE a scale) a)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 32)) (y (_ BitVec 32))) (_ BitVec 32)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
(define-fun _bv_nxor ((x (_ BitVec 32)) (y (_ BitVec 32))) (_ BitVec 32)

    (bvand (bvor x y) (bvor (bvnot x) (bvnot y)))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 32))
(declare-fun my_new_bv_goal () (_ BitVec 34))
; constraints
(assert (= ((_ to_fp 8 24) my_new_bv_support) a))

(assert (=> (= #b0 ((_ extract 33 33) my_new_bv_goal)) (not (fp.isNaN a))))
(assert (=> (= #b0 ((_ extract 32 32) my_new_bv_goal)) (fp.isNegative a))))
(assert (=  ((_ extract 31 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b00 ((_ extract 33 32) my_new_bv_goal)) #b11111111111111111111111111111111
                     (ite (= #b01 ((_ extract 33 32) my_new_bv_goal)) #b00000000000000000000000000000000
                                                                          #b00000000000000000000000000000000
            )))
))
(minimize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (a))
(get-objectives)

(get-model)
(exit)
