(set-info :smt-lib-version 2.6)
(set-info :category "crafted")
(set-info :source |Christoph M. Wintersteiger (cwinter@microsoft.com). Randomly generated floating-point testcases.|)
; Rounding mode: to negative
; Precision: double (11/53)
; X = 1.239352166618228778816046542488038539886474609375p388 {+ 1077946328392176 388 (7.81327e+116)}
; 1.239352166618228778816046542488038539886474609375p388 | == 1.239352166618228778816046542488038539886474609375p388
; [HW: 1.239352166618228778816046542488038539886474609375p388] 

; mpf : + 1077946328392176 388
; mpfd: + 1077946328392176 388 (7.81327e+116) class: Pos. norm. non-zero
; hwf : + 1077946328392176 388 (7.81327e+116) class: Pos. norm. non-zero

(set-logic QF_FP)
(set-option :produce-models true)
(define-sort FPN () (_ FloatingPoint 11 53))
(declare-fun x () FPN)
(declare-fun r () FPN)
(assert (= x (fp #b0 #b10110000011 #b0011110101000110001011101111111111011010000111110000)))
;(assert (= r (fp #b0 #b10110000011 #b0011110101000110001011101111111111011010000111110000)))
(assert (= (fp.abs x) r))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
(define-fun _bv_nxor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)

    (bvand (bvor x y) (bvor (bvnot x) (bvnot y)))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 64))
(declare-fun my_new_bv_goal () (_ BitVec 66))
; constraints
(assert (= ((_ to_fp 11 53) my_new_bv_support) r))

(assert (=> (= #b0 ((_ extract 65 65) my_new_bv_goal)) (not (fp.isNaN r))))
(assert (=> (= #b0 ((_ extract 64 64) my_new_bv_goal)) (fp.isNegative r))))
(assert (=  ((_ extract 63 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b00 ((_ extract 65 64) my_new_bv_goal)) #b1111111111111111111111111111111111111111111111111111111111111111
                     (ite (= #b01 ((_ extract 65 64) my_new_bv_goal)) #b0000000000000000000000000000000000000000000000000000000000000000
                                                                          #b0000000000000000000000000000000000000000000000000000000000000000
            )))
))
(minimize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (r))
(get-objectives)

(get-model)
(exit)
