(set-info :smt-lib-version 2.6)
(set-info :category "crafted")
(set-info :source |Christoph M. Wintersteiger (cwinter@microsoft.com). Randomly generated floating-point testcases.|)
; Rounding mode: nearest, ties to even
; Precision: double (11/53)
; X = -zero {- 0 -1023 (-0)}
; Y = 1.6331477293733254185781333944760262966156005859375p984 {+ 2851443878076184 984 (2.67018e+296)}
; -zero / 1.6331477293733254185781333944760262966156005859375p984 == -zero
; [HW: -zero] 

; mpf : - 0 -1023
; mpfd: - 0 -1023 (-0) class: -0
; hwf : - 0 -1023 (-0) class: -0

(set-logic QF_FP)
(set-option :produce-models true)
(define-sort FPN () (_ FloatingPoint 11 53))
(declare-fun x () FPN)
(declare-fun y () FPN)
(declare-fun r () FPN)
(assert (fp.leq x (fp #b1 #b00000000000 #b0000000000000000000000000000000000000000000000000000)))
(assert (= y (fp #b0 #b11111010111 #b1010001000010101111110000011011100110001111100011000)))
;(assert (= r (fp #b1 #b00000000000 #b0000000000000000000000000000000000000000000000000000)))
(assert (= (fp.div roundNearestTiesToEven x y) r))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 64))
(declare-fun my_new_bv_goal () (_ BitVec 66))
; constraints
(assert (= ((_ to_fp 11 53) my_new_bv_support) r))
(assert (=> (= #b1 ((_ extract 65 65) my_new_bv_goal)) (not (fp.isNaN r))))
(assert (=> (= #b1 ((_ extract 64 64) my_new_bv_goal)) (fp.isPositive r))))
(assert (=  ((_ extract 63 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b11 ((_ extract 65 64) my_new_bv_goal)) #b0111111111111111111111111111111111111111111111111111111111111111
                     (ite (= #b10 ((_ extract 65 64) my_new_bv_goal)) #b1000000000000000000000000000000000000000000000000000000000000000
                                                                          #b0000000000000000000000000000000000000000000000000000000000000000
            )))
))
(maximize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (r))
(get-objectives)

(get-model)
(exit)
