(set-info :smt-lib-version 2.6)
(set-info :category "crafted")
(set-info :source |Christoph M. Wintersteiger (cwinter@microsoft.com). Randomly generated floating-point testcases.|)
; Rounding mode: nearest, ties to even
; Precision: double (11/53)
; X = -1.075665769570374408203861094079911708831787109375p792 {- 340768331641840 792 (-2.80178e+238)}
; Y = -1.4660960389428996375471569990622811019420623779296875p-387 {- 2099109947302107 -387 (-4.65108e-117)}
; -1.075665769570374408203861094079911708831787109375p792 < -1.4660960389428996375471569990622811019420623779296875p-387 == 1

; bres: 1
; hwf : 1

(set-logic QF_FP)
(set-option :produce-models true)
(define-sort FPN () (_ FloatingPoint 11 53))
(declare-fun x () FPN)
(declare-fun y () FPN)
(assert (fp.leq x (fp #b1 #b11100010111 #b0001001101011110110101001111010110111011001111110000)))
(assert (fp.geq y (fp #b1 #b01001111100 #b0111011101010010000100011110110000001110000011011011)))
(assert (= (fp.lt x y) true))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
(define-fun _bv_nxor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)

    (bvand (bvor x y) (bvor (bvnot x) (bvnot y)))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 64))
(declare-fun my_new_bv_goal () (_ BitVec 66))
; constraints
(assert (= ((_ to_fp 11 53) my_new_bv_support) y))

(assert (=> (= #b0 ((_ extract 65 65) my_new_bv_goal)) (not (fp.isNaN y))))
(assert (=> (= #b0 ((_ extract 64 64) my_new_bv_goal)) (fp.isNegative y))))
(assert (=  ((_ extract 63 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b00 ((_ extract 65 64) my_new_bv_goal)) #b1111111111111111111111111111111111111111111111111111111111111111
                     (ite (= #b01 ((_ extract 65 64) my_new_bv_goal)) #b0000000000000000000000000000000000000000000000000000000000000000
                                                                          #b0000000000000000000000000000000000000000000000000000000000000000
            )))
))
(minimize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (y))
(get-objectives)

(get-model)
(exit)
