(set-info :smt-lib-version 2.6)
(set-info :category "crafted")
(set-info :source |Christoph M. Wintersteiger (cwinter@microsoft.com). Randomly generated floating-point testcases.|)
; Rounding mode: nearest, ties to even
; Precision: double (11/53)
; X = 1.4302108174659122763472396400175057351589202880859375p-211 {+ 1937497277230239 -211 (4.34581e-064)}
; 1.4302108174659122763472396400175057351589202880859375p-211 S == 1.691278106915543588684158748947083950042724609375p-106
; [HW: 1.691278106915543588684158748947083950042724609375p-106] 

; mpf : + 3113239824714224 -106
; mpfd: + 3113239824714224 -106 (2.08466e-032) class: Pos. norm. non-zero
; hwf : + 3113239824714224 -106 (2.08466e-032) class: Pos. norm. non-zero

(set-logic QF_FP)
(set-option :produce-models true)
(define-sort FPN () (_ FloatingPoint 11 53))
(declare-fun x () FPN)
(declare-fun r () FPN)
(assert (fp.geq x (fp #b0 #b01100101100 #b0110111000100010010010111100111101100110110010011111)))
;(assert (= r (fp #b0 #b01110010101 #b1011000011110111100110100001110110100100100111110000)))
(assert (= (fp.sqrt roundNearestTiesToEven x) r))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
(define-fun _bv_nxor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)

    (bvand (bvor x y) (bvor (bvnot x) (bvnot y)))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 64))
(declare-fun my_new_bv_goal () (_ BitVec 66))
; constraints
(assert (= ((_ to_fp 11 53) my_new_bv_support) r))

(assert (=> (= #b0 ((_ extract 65 65) my_new_bv_goal)) (not (fp.isNaN r))))
(assert (=> (= #b0 ((_ extract 64 64) my_new_bv_goal)) (fp.isNegative r))))
(assert (=  ((_ extract 63 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b00 ((_ extract 65 64) my_new_bv_goal)) #b1111111111111111111111111111111111111111111111111111111111111111
                     (ite (= #b01 ((_ extract 65 64) my_new_bv_goal)) #b0000000000000000000000000000000000000000000000000000000000000000
                                                                          #b0000000000000000000000000000000000000000000000000000000000000000
            )))
))
(minimize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (r))
(get-objectives)

(get-model)
(exit)
