(set-info :smt-lib-version 2.6)
; Rounding mode: to positive
; Precision: double (11/53)
; X = -1.43191837671887700622619377099908888339996337890625 790 {- 1945187440445604 790 (-9.32427e+237)}
; -1.43191837671887700622619377099908888339996337890625 790 I == -1.43191837671887700622619377099908888339996337890625 790
; [HW: -1.43191837671887700622619377099908888339996337890625 790] 

; mpf : - 1945187440445604 790
; mpfd: - 1945187440445604 790 (-9.32427e+237) class: Neg. norm. non-zero
; hwf : - 1945187440445604 790 (-9.32427e+237) class: Neg. norm. non-zero

(set-logic QF_FP)
(set-info :source |Christoph M. Wintersteiger (cwinter@microsoft.com). Randomly generated floating-point testcases.|)
(set-info :category "crafted")
(set-option :produce-models true)
(define-sort FPN () (_ FloatingPoint 11 53))
(declare-fun x () FPN)
(declare-fun r () FPN)
(assert (fp.geq x (fp #b1 #b11100010101 #b0110111010010010001100111110011010001100100010100100)))
;(assert (= r (fp #b1 #b11100010101 #b0110111010010010001100111110011010001100100010100100)))
(assert (= (fp.roundToIntegral roundTowardPositive x) r))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; support functions
(define-fun _bv_xor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)
    (bvor (bvand x (bvnot y)) (bvand (bvnot x) y))
)
(define-fun _bv_nxor ((x (_ BitVec 64)) (y (_ BitVec 64))) (_ BitVec 64)

    (bvand (bvor x y) (bvor (bvnot x) (bvnot y)))
)
; support variables
(declare-fun my_new_bv_support () (_ BitVec 64))
(declare-fun my_new_bv_goal () (_ BitVec 66))
; constraints
(assert (= ((_ to_fp 11 53) my_new_bv_support) r))

(assert (=> (= #b0 ((_ extract 65 65) my_new_bv_goal)) (not (fp.isNaN r))))
(assert (=> (= #b0 ((_ extract 64 64) my_new_bv_goal)) (fp.isNegative r))))
(assert (=  ((_ extract 63 0) my_new_bv_goal)
            (_bv_xor my_new_bv_support
                     (ite (= #b00 ((_ extract 65 64) my_new_bv_goal)) #b1111111111111111111111111111111111111111111111111111111111111111
                     (ite (= #b01 ((_ extract 65 64) my_new_bv_goal)) #b0000000000000000000000000000000000000000000000000000000000000000
                                                                          #b0000000000000000000000000000000000000000000000000000000000000000
            )))
))
(minimize my_new_bv_goal)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(check-sat)
(get-value (r))
(get-objectives)

(get-model)
(exit)
