#!/bin/bash

TIMEOUT=605    # s.
SLEEP_TIME=5   # s.

if (( $# < 1 )); then
	echo "usage: pkiller.sh tool_name ..."
	exit 1
fi

declare -a last_values
last_values=($(for ((i=0;i<${#};i++)); do echo "-empty-"; done) );

while true :
do
	sleep ${SLEEP_TIME}

	idx=$((0))
	for command in "$@"
	do
		output=$(pgrep "${command}" | xargs --no-run-if-empty ps --no-headers -o pid,time,cmd -p | head -n 1 | sed 's/^ *//' )

		ptime=$(echo "${output}" | cut -d\  -f2)

		if [[ -n "${ptime}" ]]; then

			time_in_seconds=$(case "${#ptime}" in "8") echo "${ptime: -2}"+"${ptime: -5:2}"*60+"${ptime: -8:2}"*3600 | bc;;  "5")  echo "${ptime: -2}"+"${ptime: -5:2}"*60 | bc;; *) echo $(echo "$ptime" | cut -d'-' -f1)*86400+"${ptime: -2}"+"${ptime: -5:2}"*60+"${ptime: -8:2}"*3600 | bc;; esac)

			if (( time_in_seconds > (TIMEOUT - SLEEP_TIME) )) || (( time_in_seconds > TIMEOUT )); then
				if [[ "${last_values[${idx}]}" = "${ptime}" ]] || (( time_in_seconds > TIMEOUT )); then
					pid=$(echo "${output}" | cut -d\  -f1)

					echo "Killing '${command}' ..."
					echo -e "\t${output}"

					kill -9 "${pid}"

					last_values[${idx}]="-empty-"
				else
					echo "Preparing to kill '${command}' ..."
					echo -e "\t${output}"
					last_values[${idx}]="${ptime}"
				fi
			fi
		fi
		idx=$((idx + 1))
	done
done
