/*
 * JNI wrapper implementation automatically generated by extract_java_stub.py
 */
#include <stdlib.h>
#include "mathsat_api.h"


#include "mathsat.h"
#include "msatexistelim.h"
#include <stdlib.h>
#include <string.h>


struct j_msat_callback_helper {
   JNIEnv *jenv;
   jobject obj;
};

static int call_java_allsat_callback(msat_term *model, int size,
                                     void *user_data)
{
    struct j_msat_callback_helper *helper =
        (struct j_msat_callback_helper *)user_data;

    const char *signature = "([J)I";
    jclass cls = (*(helper->jenv))->FindClass(helper->jenv,
                                              "mathsat/AllSatModelCallback");
    jmethodID mid = (*(helper->jenv))->GetMethodID(helper->jenv, cls,
                                                   "callback", signature);    
        
    jlongArray jmodel = (*(helper->jenv))->NewLongArray(helper->jenv,
                                                        (size_t)size);
    jlong *jarr = malloc(sizeof(jlong) * size);
    int i;
    int retval;
    
    for (i = 0; i < size; ++i) {
        jarr[i] = (jlong)((size_t)model[i].repr);
    }
    (*(helper->jenv))->SetLongArrayRegion(helper->jenv, jmodel, 0, (size_t)size,
                                          (jlong *)jarr);

    retval = (*(helper->jenv))->CallIntMethod(helper->jenv, helper->obj,
                                              mid, jmodel);
    free(jarr);

    return retval;
}

static msat_visit_status call_java_visit_callback(msat_env e, msat_term term,
                                                  int preorder, void *user_data)
{
    struct j_msat_callback_helper *helper =
        (struct j_msat_callback_helper *)user_data;

    const char *signature = "(JJZ)I";
    jclass cls = (*(helper->jenv))->FindClass(helper->jenv,
                                              "mathsat/VisitTermCallback");
    jmethodID mid = (*(helper->jenv))->GetMethodID(helper->jenv, cls,
                                                   "callback", signature);    

    jlong je = (jlong)((size_t)e.repr);
    jlong jterm = (jlong)((size_t)term.repr);
    jboolean jpreorder = (jboolean)preorder;

    int retval = (*(helper->jenv))->CallIntMethod(helper->jenv, helper->obj,
                                                  mid, je, jterm, jpreorder);

    return (msat_visit_status)retval;
}

static int call_java_termtest(void *user_data)
{
    struct j_msat_callback_helper *helper =
        (struct j_msat_callback_helper *)user_data;

    const char *signature = "()I";
    jclass cls = (*(helper->jenv))->FindClass(helper->jenv,
                                              "mathsat/TerminationTest");
    jmethodID mid = (*(helper->jenv))->GetMethodID(helper->jenv, cls,
                                                   "callback", signature);    
        
    int retval = (*(helper->jenv))->CallIntMethod(helper->jenv, helper->obj,
                                                  mid);

    return retval;
}


static int call_java_solve_diversify_callback(msat_model_iterator it,
                                              void *user_data)
{
    struct j_msat_callback_helper *helper =
        (struct j_msat_callback_helper *)user_data;

    const char *signature = "(J)I";
    jclass cls = (*(helper->jenv))->FindClass(helper->jenv,
                                              "mathsat/SolveDiversifyModelCallback");
    jmethodID mid = (*(helper->jenv))->GetMethodID(helper->jenv, cls,
                                                   "callback", signature);    

    jlong jiter = (jlong)((size_t)it.repr);

    int retval = (*(helper->jenv))->CallIntMethod(helper->jenv, helper->obj,
                                                  mid, jiter);

    return retval;
}


JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1get_1version
  (JNIEnv *jenv, jclass jcls)
{
  char * msat_get_version_retval;
  jstring msat_get_version_jretval;
  


  msat_get_version_retval = msat_get_version();

  msat_get_version_jretval = (*jenv)->NewStringUTF(jenv, msat_get_version_retval);

  return msat_get_version_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1last_1error_1message
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_env;
  const char * msat_last_error_message_retval;
  jstring msat_last_error_message_jretval;
  

arg1_env.repr = (void *)((size_t)arg1);

  msat_last_error_message_retval = msat_last_error_message(arg1_env);

  msat_last_error_message_jretval = (*jenv)->NewStringUTF(jenv, msat_last_error_message_retval);

  return msat_last_error_message_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1config
  (JNIEnv *jenv, jclass jcls)
{
  msat_config msat_create_config_retval;
  jlong msat_create_config_jretval;
  


  msat_create_config_retval = msat_create_config();

  msat_create_config_jretval = (jlong)((size_t)(msat_create_config_retval.repr));

  return msat_create_config_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1default_1config
  (JNIEnv *jenv, jclass jcls, jstring arg1)
{
  char * arg1_logic;
  msat_config msat_create_default_config_retval;
  jlong msat_create_default_config_jretval;
  

arg1_logic = (char *)(*jenv)->GetStringUTFChars(jenv, arg1, NULL);

  msat_create_default_config_retval = msat_create_default_config(arg1_logic);

  msat_create_default_config_jretval = (jlong)((size_t)(msat_create_default_config_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg1, arg1_logic);

  return msat_create_default_config_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1parse_1config
  (JNIEnv *jenv, jclass jcls, jstring arg1)
{
  char * arg1_data;
  msat_config msat_parse_config_retval;
  jlong msat_parse_config_jretval;
  

arg1_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg1, NULL);

  msat_parse_config_retval = msat_parse_config(arg1_data);

  msat_parse_config_jretval = (jlong)((size_t)(msat_parse_config_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg1, arg1_data);

  return msat_parse_config_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1config
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_config arg1_cfg;
  

arg1_cfg.repr = (void *)((size_t)arg1);

  msat_destroy_config(arg1_cfg);

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_config arg1_cfg;
  msat_env msat_create_env_retval;
  jlong msat_create_env_jretval;
  

arg1_cfg.repr = (void *)((size_t)arg1);

  msat_create_env_retval = msat_create_env(arg1_cfg);

  msat_create_env_jretval = (jlong)((size_t)(msat_create_env_retval.repr));

  return msat_create_env_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1shared_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_config arg1_cfg;
  msat_env arg2_sibling;
  msat_env msat_create_shared_env_retval;
  jlong msat_create_shared_env_jretval;
  
  

arg1_cfg.repr = (void *)((size_t)arg1);
arg2_sibling.repr = (void *)((size_t)arg2);

  msat_create_shared_env_retval = msat_create_shared_env(arg1_cfg, arg2_sibling);

  msat_create_shared_env_jretval = (jlong)((size_t)(msat_create_shared_env_retval.repr));

  return msat_create_shared_env_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_destroy_env(arg1_e);

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1gc_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jint arg3)
{
  msat_env arg1_env;
  msat_term * arg2_tokeep;
  size_t arg3_num_tokeep;
  int msat_gc_env_retval;
  jint msat_gc_env_jretval;
  
  
  

arg1_env.repr = (void *)((size_t)arg1);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg2, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg2));
  arg2_tokeep = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg2_tokeep[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg2, tmp, 0);
}

arg3_num_tokeep = arg3;

  msat_gc_env_retval = msat_gc_env(arg1_env, arg2_tokeep, arg3_num_tokeep);

  msat_gc_env_jretval = (jint)msat_gc_env_retval;
free(arg2_tokeep);

  return msat_gc_env_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1set_1option
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jstring arg3)
{
  msat_config arg1_cfg;
  char * arg2_option;
  char * arg3_value;
  int msat_set_option_retval;
  jint msat_set_option_jretval;
  
  
  

arg1_cfg.repr = (void *)((size_t)arg1);
arg2_option = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
arg3_value = (char *)(*jenv)->GetStringUTFChars(jenv, arg3, NULL);

  msat_set_option_retval = msat_set_option(arg1_cfg, arg2_option, arg3_value);

  msat_set_option_jretval = (jint)msat_set_option_retval;
(*jenv)->ReleaseStringUTFChars(jenv, arg3, arg3_value);
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_option);

  return msat_set_option_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1set_1termination_1test
  (JNIEnv *jenv, jclass jcls, jlong arg1, jobject arg2, jint arg3)
{
    struct j_msat_callback_helper helper = {jenv, arg2};
    msat_env e;
    int retval;
  
    e.repr = (void *)((size_t)arg1);

    retval = msat_set_termination_test(e, call_java_termtest, &helper);

    return retval;
}


JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1bool_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_env;
  msat_type msat_get_bool_type_retval;
  jlong msat_get_bool_type_jretval;
  

arg1_env.repr = (void *)((size_t)arg1);

  msat_get_bool_type_retval = msat_get_bool_type(arg1_env);

  msat_get_bool_type_jretval = (jlong)((size_t)(msat_get_bool_type_retval.repr));

  return msat_get_bool_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1rational_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_env;
  msat_type msat_get_rational_type_retval;
  jlong msat_get_rational_type_jretval;
  

arg1_env.repr = (void *)((size_t)arg1);

  msat_get_rational_type_retval = msat_get_rational_type(arg1_env);

  msat_get_rational_type_jretval = (jlong)((size_t)(msat_get_rational_type_retval.repr));

  return msat_get_rational_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1integer_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_env;
  msat_type msat_get_integer_type_retval;
  jlong msat_get_integer_type_jretval;
  

arg1_env.repr = (void *)((size_t)arg1);

  msat_get_integer_type_retval = msat_get_integer_type(arg1_env);

  msat_get_integer_type_jretval = (jlong)((size_t)(msat_get_integer_type_retval.repr));

  return msat_get_integer_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1bv_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_env;
  size_t arg2_width;
  msat_type msat_get_bv_type_retval;
  jlong msat_get_bv_type_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_width = arg2;

  msat_get_bv_type_retval = msat_get_bv_type(arg1_env, arg2_width);

  msat_get_bv_type_jretval = (jlong)((size_t)(msat_get_bv_type_retval.repr));

  return msat_get_bv_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1array_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_env;
  msat_type arg2_itp;
  msat_type arg3_etp;
  msat_type msat_get_array_type_retval;
  jlong msat_get_array_type_jretval;
  
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_itp.repr = (void *)((size_t)arg2);
arg3_etp.repr = (void *)((size_t)arg3);

  msat_get_array_type_retval = msat_get_array_type(arg1_env, arg2_itp, arg3_etp);

  msat_get_array_type_jretval = (jlong)((size_t)(msat_get_array_type_retval.repr));

  return msat_get_array_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1fp_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3)
{
  msat_env arg1_env;
  size_t arg2_exp_width;
  size_t arg3_mant_width;
  msat_type msat_get_fp_type_retval;
  jlong msat_get_fp_type_jretval;
  
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_exp_width = arg2;
arg3_mant_width = arg3;

  msat_get_fp_type_retval = msat_get_fp_type(arg1_env, arg2_exp_width, arg3_mant_width);

  msat_get_fp_type_jretval = (jlong)((size_t)(msat_get_fp_type_retval.repr));

  return msat_get_fp_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1fp_1roundingmode_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_env;
  msat_type msat_get_fp_roundingmode_type_retval;
  jlong msat_get_fp_roundingmode_type_jretval;
  

arg1_env.repr = (void *)((size_t)arg1);

  msat_get_fp_roundingmode_type_retval = msat_get_fp_roundingmode_type(arg1_env);

  msat_get_fp_roundingmode_type_jretval = (jlong)((size_t)(msat_get_fp_roundingmode_type_retval.repr));

  return msat_get_fp_roundingmode_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1simple_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_env;
  char * arg2_name;
  msat_type msat_get_simple_type_retval;
  jlong msat_get_simple_type_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_name = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);

  msat_get_simple_type_retval = msat_get_simple_type(arg1_env, arg2_name);

  msat_get_simple_type_jretval = (jlong)((size_t)(msat_get_simple_type_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_name);

  return msat_get_simple_type_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1function_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jint arg3, jlong arg4)
{
  msat_env arg1_env;
  msat_type * arg2_param_types;
  size_t arg3_num_params;
  msat_type arg4_return_type;
  msat_type msat_get_function_type_retval;
  jlong msat_get_function_type_jretval;
  
  
  
  

arg1_env.repr = (void *)((size_t)arg1);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg2, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg2));
  arg2_param_types = (msat_type *)malloc(sizeof(msat_type) * sz);
  for (i = 0; i < sz; ++i) {
     arg2_param_types[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg2, tmp, 0);
}

arg3_num_params = arg3;
arg4_return_type.repr = (void *)((size_t)arg4);

  msat_get_function_type_retval = msat_get_function_type(arg1_env, arg2_param_types, arg3_num_params, arg4_return_type);

  msat_get_function_type_jretval = (jlong)((size_t)(msat_get_function_type_retval.repr));
free(arg2_param_types);

  return msat_get_function_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1is_1bool_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_env;
  msat_type arg2_tp;
  int msat_is_bool_type_retval;
  jint msat_is_bool_type_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_tp.repr = (void *)((size_t)arg2);

  msat_is_bool_type_retval = msat_is_bool_type(arg1_env, arg2_tp);

  msat_is_bool_type_jretval = (jint)msat_is_bool_type_retval;

  return msat_is_bool_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1is_1rational_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_env;
  msat_type arg2_tp;
  int msat_is_rational_type_retval;
  jint msat_is_rational_type_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_tp.repr = (void *)((size_t)arg2);

  msat_is_rational_type_retval = msat_is_rational_type(arg1_env, arg2_tp);

  msat_is_rational_type_jretval = (jint)msat_is_rational_type_retval;

  return msat_is_rational_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1is_1integer_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_env;
  msat_type arg2_tp;
  int msat_is_integer_type_retval;
  jint msat_is_integer_type_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_tp.repr = (void *)((size_t)arg2);

  msat_is_integer_type_retval = msat_is_integer_type(arg1_env, arg2_tp);

  msat_is_integer_type_jretval = (jint)msat_is_integer_type_retval;

  return msat_is_integer_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1is_1bv_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jintArray arg3)
{
  msat_env arg1_env;
  msat_type arg2_tp;
  size_t * arg3_out_width;
  int msat_is_bv_type_retval;
  jint msat_is_bv_type_jretval;
  
  
  size_t ptrarg3_out_width;

arg1_env.repr = (void *)((size_t)arg1);
arg2_tp.repr = (void *)((size_t)arg2);
/*size_t ptrarg3_out_width;*/
arg3_out_width = &ptrarg3_out_width;


  msat_is_bv_type_retval = msat_is_bv_type(arg1_env, arg2_tp, arg3_out_width);

  msat_is_bv_type_jretval = (jint)msat_is_bv_type_retval;
(*jenv)->SetIntArrayRegion(jenv, arg3, 0, 1, (jint *)&(ptrarg3_out_width));


  return msat_is_bv_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1is_1array_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3, jlongArray arg4)
{
  msat_env arg1_env;
  msat_type arg2_tp;
  msat_type * arg3_out_itp;
  msat_type * arg4_out_etp;
  int msat_is_array_type_retval;
  jint msat_is_array_type_jretval;
  
  
  msat_type ptrarg3_out_itp;
  msat_type ptrarg4_out_etp;

arg1_env.repr = (void *)((size_t)arg1);
arg2_tp.repr = (void *)((size_t)arg2);
/*msat_type ptrarg3_out_itp;*/
arg3_out_itp = &ptrarg3_out_itp;

/*msat_type ptrarg4_out_etp;*/
arg4_out_etp = &ptrarg4_out_etp;


  msat_is_array_type_retval = msat_is_array_type(arg1_env, arg2_tp, arg3_out_itp, arg4_out_etp);

  msat_is_array_type_jretval = (jint)msat_is_array_type_retval;
(*jenv)->SetLongArrayRegion(jenv, arg4, 0, 1, (jlong *)&(ptrarg4_out_etp.repr));

(*jenv)->SetLongArrayRegion(jenv, arg3, 0, 1, (jlong *)&(ptrarg3_out_itp.repr));


  return msat_is_array_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1is_1fp_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jintArray arg3, jintArray arg4)
{
  msat_env arg1_env;
  msat_type arg2_tp;
  size_t * arg3_out_exp_width;
  size_t * arg4_out_mant_width;
  int msat_is_fp_type_retval;
  jint msat_is_fp_type_jretval;
  
  
  size_t ptrarg3_out_exp_width;
  size_t ptrarg4_out_mant_width;

arg1_env.repr = (void *)((size_t)arg1);
arg2_tp.repr = (void *)((size_t)arg2);
/*size_t ptrarg3_out_exp_width;*/
arg3_out_exp_width = &ptrarg3_out_exp_width;

/*size_t ptrarg4_out_mant_width;*/
arg4_out_mant_width = &ptrarg4_out_mant_width;


  msat_is_fp_type_retval = msat_is_fp_type(arg1_env, arg2_tp, arg3_out_exp_width, arg4_out_mant_width);

  msat_is_fp_type_jretval = (jint)msat_is_fp_type_retval;
(*jenv)->SetIntArrayRegion(jenv, arg4, 0, 1, (jint *)&(ptrarg4_out_mant_width));

(*jenv)->SetIntArrayRegion(jenv, arg3, 0, 1, (jint *)&(ptrarg3_out_exp_width));


  return msat_is_fp_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1is_1fp_1roundingmode_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_env;
  msat_type arg2_tp;
  int msat_is_fp_roundingmode_type_retval;
  jint msat_is_fp_roundingmode_type_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_tp.repr = (void *)((size_t)arg2);

  msat_is_fp_roundingmode_type_retval = msat_is_fp_roundingmode_type(arg1_env, arg2_tp);

  msat_is_fp_roundingmode_type_jretval = (jint)msat_is_fp_roundingmode_type_retval;

  return msat_is_fp_roundingmode_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1type_1equals
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_type arg1_t1;
  msat_type arg2_t2;
  int msat_type_equals_retval;
  jint msat_type_equals_jretval;
  
  

arg1_t1.repr = (void *)((size_t)arg1);
arg2_t2.repr = (void *)((size_t)arg2);

  msat_type_equals_retval = msat_type_equals(arg1_t1, arg2_t2);

  msat_type_equals_jretval = (jint)msat_type_equals_retval;

  return msat_type_equals_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1type_1repr
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_type arg1_t;
  char * msat_type_repr_retval;
  jstring msat_type_repr_jretval;
  

arg1_t.repr = (void *)((size_t)arg1);

  msat_type_repr_retval = msat_type_repr(arg1_t);

  msat_type_repr_jretval = (*jenv)->NewStringUTF(jenv, msat_type_repr_retval);

  return msat_type_repr_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1declare_1function
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jlong arg3)
{
  msat_env arg1_e;
  char * arg2_name;
  msat_type arg3_type;
  msat_decl msat_declare_function_retval;
  jlong msat_declare_function_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_name = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
arg3_type.repr = (void *)((size_t)arg3);

  msat_declare_function_retval = msat_declare_function(arg1_e, arg2_name, arg3_type);

  msat_declare_function_jretval = (jlong)((size_t)(msat_declare_function_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_name);

  return msat_declare_function_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1true
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_true_retval;
  jlong msat_make_true_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_true_retval = msat_make_true(arg1_e);

  msat_make_true_jretval = (jlong)((size_t)(msat_make_true_retval.repr));

  return msat_make_true_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1false
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_false_retval;
  jlong msat_make_false_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_false_retval = msat_make_false(arg1_e);

  msat_make_false_jretval = (jlong)((size_t)(msat_make_false_retval.repr));

  return msat_make_false_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1iff
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_iff_retval;
  jlong msat_make_iff_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_iff_retval = msat_make_iff(arg1_e, arg2_t1, arg3_t2);

  msat_make_iff_jretval = (jlong)((size_t)(msat_make_iff_retval.repr));

  return msat_make_iff_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_or_retval;
  jlong msat_make_or_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_or_retval = msat_make_or(arg1_e, arg2_t1, arg3_t2);

  msat_make_or_jretval = (jlong)((size_t)(msat_make_or_retval.repr));

  return msat_make_or_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_and_retval;
  jlong msat_make_and_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_and_retval = msat_make_and(arg1_e, arg2_t1, arg3_t2);

  msat_make_and_jretval = (jlong)((size_t)(msat_make_and_retval.repr));

  return msat_make_and_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term msat_make_not_retval;
  jlong msat_make_not_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);

  msat_make_not_retval = msat_make_not(arg1_e, arg2_t1);

  msat_make_not_jretval = (jlong)((size_t)(msat_make_not_retval.repr));

  return msat_make_not_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1equal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_equal_retval;
  jlong msat_make_equal_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_equal_retval = msat_make_equal(arg1_e, arg2_t1, arg3_t2);

  msat_make_equal_jretval = (jlong)((size_t)(msat_make_equal_retval.repr));

  return msat_make_equal_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1eq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_eq_retval;
  jlong msat_make_eq_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_eq_retval = msat_make_eq(arg1_e, arg2_t1, arg3_t2);

  msat_make_eq_jretval = (jlong)((size_t)(msat_make_eq_retval.repr));

  return msat_make_eq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1leq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_leq_retval;
  jlong msat_make_leq_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_leq_retval = msat_make_leq(arg1_e, arg2_t1, arg3_t2);

  msat_make_leq_jretval = (jlong)((size_t)(msat_make_leq_retval.repr));

  return msat_make_leq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_plus_retval;
  jlong msat_make_plus_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_plus_retval = msat_make_plus(arg1_e, arg2_t1, arg3_t2);

  msat_make_plus_jretval = (jlong)((size_t)(msat_make_plus_retval.repr));

  return msat_make_plus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_times_retval;
  jlong msat_make_times_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_times_retval = msat_make_times(arg1_e, arg2_t1, arg3_t2);

  msat_make_times_jretval = (jlong)((size_t)(msat_make_times_retval.repr));

  return msat_make_times_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1divide
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_divide_retval;
  jlong msat_make_divide_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_divide_retval = msat_make_divide(arg1_e, arg2_t1, arg3_t2);

  msat_make_divide_jretval = (jlong)((size_t)(msat_make_divide_retval.repr));

  return msat_make_divide_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1int_1modular_1congruence
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  mpz_t arg2_modulus;
  msat_term arg3_t1;
  msat_term arg4_t2;
  msat_term msat_make_int_modular_congruence_retval;
  jlong msat_make_int_modular_congruence_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
{
char *strarg2_modulus = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
mpz_init_set_str(arg2_modulus, strarg2_modulus, 10);
(*jenv)->ReleaseStringUTFChars(jenv, arg2, strarg2_modulus);
}

arg3_t1.repr = (void *)((size_t)arg3);
arg4_t2.repr = (void *)((size_t)arg4);

  msat_make_int_modular_congruence_retval = msat_make_int_modular_congruence(arg1_e, arg2_modulus, arg3_t1, arg4_t2);

  msat_make_int_modular_congruence_jretval = (jlong)((size_t)(msat_make_int_modular_congruence_retval.repr));
mpz_clear(arg2_modulus);

  return msat_make_int_modular_congruence_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1floor
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_floor_retval;
  jlong msat_make_floor_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_floor_retval = msat_make_floor(arg1_e, arg2_t);

  msat_make_floor_jretval = (jlong)((size_t)(msat_make_floor_retval.repr));

  return msat_make_floor_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1number
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_num_rep;
  msat_term msat_make_number_retval;
  jlong msat_make_number_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_num_rep = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);

  msat_make_number_retval = msat_make_number(arg1_e, arg2_num_rep);

  msat_make_number_jretval = (jlong)((size_t)(msat_make_number_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_num_rep);

  return msat_make_number_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1term_1ite
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  msat_term arg2_c;
  msat_term arg3_tt;
  msat_term arg4_te;
  msat_term msat_make_term_ite_retval;
  jlong msat_make_term_ite_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_c.repr = (void *)((size_t)arg2);
arg3_tt.repr = (void *)((size_t)arg3);
arg4_te.repr = (void *)((size_t)arg4);

  msat_make_term_ite_retval = msat_make_term_ite(arg1_e, arg2_c, arg3_tt, arg4_te);

  msat_make_term_ite_jretval = (jlong)((size_t)(msat_make_term_ite_retval.repr));

  return msat_make_term_ite_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1constant
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_decl arg2_var;
  msat_term msat_make_constant_retval;
  jlong msat_make_constant_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_var.repr = (void *)((size_t)arg2);

  msat_make_constant_retval = msat_make_constant(arg1_e, arg2_var);

  msat_make_constant_jretval = (jlong)((size_t)(msat_make_constant_retval.repr));

  return msat_make_constant_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1uf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3)
{
  msat_env arg1_e;
  msat_decl arg2_func;
  msat_term * arg3_args;
  msat_term msat_make_uf_retval;
  jlong msat_make_uf_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_func.repr = (void *)((size_t)arg2);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg3, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg3));
  arg3_args = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg3_args[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg3, tmp, 0);
}


  msat_make_uf_retval = msat_make_uf(arg1_e, arg2_func, arg3_args);

  msat_make_uf_jretval = (jlong)((size_t)(msat_make_uf_retval.repr));
free(arg3_args);

  return msat_make_uf_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1array_1read
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_arr;
  msat_term arg3_idx;
  msat_term msat_make_array_read_retval;
  jlong msat_make_array_read_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_arr.repr = (void *)((size_t)arg2);
arg3_idx.repr = (void *)((size_t)arg3);

  msat_make_array_read_retval = msat_make_array_read(arg1_e, arg2_arr, arg3_idx);

  msat_make_array_read_jretval = (jlong)((size_t)(msat_make_array_read_retval.repr));

  return msat_make_array_read_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1array_1write
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  msat_term arg2_arr;
  msat_term arg3_idx;
  msat_term arg4_elem;
  msat_term msat_make_array_write_retval;
  jlong msat_make_array_write_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_arr.repr = (void *)((size_t)arg2);
arg3_idx.repr = (void *)((size_t)arg3);
arg4_elem.repr = (void *)((size_t)arg4);

  msat_make_array_write_retval = msat_make_array_write(arg1_e, arg2_arr, arg3_idx, arg4_elem);

  msat_make_array_write_jretval = (jlong)((size_t)(msat_make_array_write_retval.repr));

  return msat_make_array_write_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1array_1const
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_type arg2_arrtp;
  msat_term arg3_elem;
  msat_term msat_make_array_const_retval;
  jlong msat_make_array_const_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_arrtp.repr = (void *)((size_t)arg2);
arg3_elem.repr = (void *)((size_t)arg3);

  msat_make_array_const_retval = msat_make_array_const(arg1_e, arg2_arrtp, arg3_elem);

  msat_make_array_const_jretval = (jlong)((size_t)(msat_make_array_const_retval.repr));

  return msat_make_array_const_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1number
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jint arg3, jint arg4)
{
  msat_env arg1_e;
  char * arg2_num_rep;
  size_t arg3_width;
  size_t arg4_base;
  msat_term msat_make_bv_number_retval;
  jlong msat_make_bv_number_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_num_rep = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
arg3_width = arg3;
arg4_base = arg4;

  msat_make_bv_number_retval = msat_make_bv_number(arg1_e, arg2_num_rep, arg3_width, arg4_base);

  msat_make_bv_number_jretval = (jlong)((size_t)(msat_make_bv_number_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_num_rep);

  return msat_make_bv_number_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1concat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_concat_retval;
  jlong msat_make_bv_concat_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_concat_retval = msat_make_bv_concat(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_concat_jretval = (jlong)((size_t)(msat_make_bv_concat_retval.repr));

  return msat_make_bv_concat_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1extract
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3, jlong arg4)
{
  msat_env arg1_e;
  size_t arg2_msb;
  size_t arg3_lsb;
  msat_term arg4_t;
  msat_term msat_make_bv_extract_retval;
  jlong msat_make_bv_extract_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_msb = arg2;
arg3_lsb = arg3;
arg4_t.repr = (void *)((size_t)arg4);

  msat_make_bv_extract_retval = msat_make_bv_extract(arg1_e, arg2_msb, arg3_lsb, arg4_t);

  msat_make_bv_extract_jretval = (jlong)((size_t)(msat_make_bv_extract_retval.repr));

  return msat_make_bv_extract_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_or_retval;
  jlong msat_make_bv_or_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_or_retval = msat_make_bv_or(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_or_jretval = (jlong)((size_t)(msat_make_bv_or_retval.repr));

  return msat_make_bv_or_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1xor
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_xor_retval;
  jlong msat_make_bv_xor_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_xor_retval = msat_make_bv_xor(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_xor_jretval = (jlong)((size_t)(msat_make_bv_xor_retval.repr));

  return msat_make_bv_xor_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_and_retval;
  jlong msat_make_bv_and_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_and_retval = msat_make_bv_and(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_and_jretval = (jlong)((size_t)(msat_make_bv_and_retval.repr));

  return msat_make_bv_and_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_bv_not_retval;
  jlong msat_make_bv_not_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_bv_not_retval = msat_make_bv_not(arg1_e, arg2_t);

  msat_make_bv_not_jretval = (jlong)((size_t)(msat_make_bv_not_retval.repr));

  return msat_make_bv_not_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1lshl
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_lshl_retval;
  jlong msat_make_bv_lshl_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_lshl_retval = msat_make_bv_lshl(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_lshl_jretval = (jlong)((size_t)(msat_make_bv_lshl_retval.repr));

  return msat_make_bv_lshl_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1lshr
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_lshr_retval;
  jlong msat_make_bv_lshr_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_lshr_retval = msat_make_bv_lshr(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_lshr_jretval = (jlong)((size_t)(msat_make_bv_lshr_retval.repr));

  return msat_make_bv_lshr_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1ashr
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_ashr_retval;
  jlong msat_make_bv_ashr_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_ashr_retval = msat_make_bv_ashr(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_ashr_jretval = (jlong)((size_t)(msat_make_bv_ashr_retval.repr));

  return msat_make_bv_ashr_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1zext
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlong arg3)
{
  msat_env arg1_e;
  size_t arg2_amount;
  msat_term arg3_t;
  msat_term msat_make_bv_zext_retval;
  jlong msat_make_bv_zext_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_amount = arg2;
arg3_t.repr = (void *)((size_t)arg3);

  msat_make_bv_zext_retval = msat_make_bv_zext(arg1_e, arg2_amount, arg3_t);

  msat_make_bv_zext_jretval = (jlong)((size_t)(msat_make_bv_zext_retval.repr));

  return msat_make_bv_zext_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sext
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlong arg3)
{
  msat_env arg1_e;
  size_t arg2_amount;
  msat_term arg3_t;
  msat_term msat_make_bv_sext_retval;
  jlong msat_make_bv_sext_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_amount = arg2;
arg3_t.repr = (void *)((size_t)arg3);

  msat_make_bv_sext_retval = msat_make_bv_sext(arg1_e, arg2_amount, arg3_t);

  msat_make_bv_sext_jretval = (jlong)((size_t)(msat_make_bv_sext_retval.repr));

  return msat_make_bv_sext_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_plus_retval;
  jlong msat_make_bv_plus_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_plus_retval = msat_make_bv_plus(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_plus_jretval = (jlong)((size_t)(msat_make_bv_plus_retval.repr));

  return msat_make_bv_plus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_minus_retval;
  jlong msat_make_bv_minus_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_minus_retval = msat_make_bv_minus(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_minus_jretval = (jlong)((size_t)(msat_make_bv_minus_retval.repr));

  return msat_make_bv_minus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1neg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_bv_neg_retval;
  jlong msat_make_bv_neg_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_bv_neg_retval = msat_make_bv_neg(arg1_e, arg2_t);

  msat_make_bv_neg_jretval = (jlong)((size_t)(msat_make_bv_neg_retval.repr));

  return msat_make_bv_neg_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_times_retval;
  jlong msat_make_bv_times_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_times_retval = msat_make_bv_times(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_times_jretval = (jlong)((size_t)(msat_make_bv_times_retval.repr));

  return msat_make_bv_times_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1udiv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_udiv_retval;
  jlong msat_make_bv_udiv_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_udiv_retval = msat_make_bv_udiv(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_udiv_jretval = (jlong)((size_t)(msat_make_bv_udiv_retval.repr));

  return msat_make_bv_udiv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1urem
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_urem_retval;
  jlong msat_make_bv_urem_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_urem_retval = msat_make_bv_urem(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_urem_jretval = (jlong)((size_t)(msat_make_bv_urem_retval.repr));

  return msat_make_bv_urem_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sdiv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_sdiv_retval;
  jlong msat_make_bv_sdiv_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_sdiv_retval = msat_make_bv_sdiv(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_sdiv_jretval = (jlong)((size_t)(msat_make_bv_sdiv_retval.repr));

  return msat_make_bv_sdiv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1srem
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_srem_retval;
  jlong msat_make_bv_srem_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_srem_retval = msat_make_bv_srem(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_srem_jretval = (jlong)((size_t)(msat_make_bv_srem_retval.repr));

  return msat_make_bv_srem_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1ult
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_ult_retval;
  jlong msat_make_bv_ult_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_ult_retval = msat_make_bv_ult(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_ult_jretval = (jlong)((size_t)(msat_make_bv_ult_retval.repr));

  return msat_make_bv_ult_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1uleq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_uleq_retval;
  jlong msat_make_bv_uleq_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_uleq_retval = msat_make_bv_uleq(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_uleq_jretval = (jlong)((size_t)(msat_make_bv_uleq_retval.repr));

  return msat_make_bv_uleq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1slt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_slt_retval;
  jlong msat_make_bv_slt_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_slt_retval = msat_make_bv_slt(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_slt_jretval = (jlong)((size_t)(msat_make_bv_slt_retval.repr));

  return msat_make_bv_slt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sleq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_sleq_retval;
  jlong msat_make_bv_sleq_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_sleq_retval = msat_make_bv_sleq(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_sleq_jretval = (jlong)((size_t)(msat_make_bv_sleq_retval.repr));

  return msat_make_bv_sleq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1rol
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlong arg3)
{
  msat_env arg1_e;
  size_t arg2_amount;
  msat_term arg3_t;
  msat_term msat_make_bv_rol_retval;
  jlong msat_make_bv_rol_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_amount = arg2;
arg3_t.repr = (void *)((size_t)arg3);

  msat_make_bv_rol_retval = msat_make_bv_rol(arg1_e, arg2_amount, arg3_t);

  msat_make_bv_rol_jretval = (jlong)((size_t)(msat_make_bv_rol_retval.repr));

  return msat_make_bv_rol_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1ror
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlong arg3)
{
  msat_env arg1_e;
  size_t arg2_amount;
  msat_term arg3_t;
  msat_term msat_make_bv_ror_retval;
  jlong msat_make_bv_ror_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_amount = arg2;
arg3_t.repr = (void *)((size_t)arg3);

  msat_make_bv_ror_retval = msat_make_bv_ror(arg1_e, arg2_amount, arg3_t);

  msat_make_bv_ror_jretval = (jlong)((size_t)(msat_make_bv_ror_retval.repr));

  return msat_make_bv_ror_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1comp
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_comp_retval;
  jlong msat_make_bv_comp_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_comp_retval = msat_make_bv_comp(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_comp_jretval = (jlong)((size_t)(msat_make_bv_comp_retval.repr));

  return msat_make_bv_comp_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1roundingmode_1nearest_1even
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_fp_roundingmode_nearest_even_retval;
  jlong msat_make_fp_roundingmode_nearest_even_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_fp_roundingmode_nearest_even_retval = msat_make_fp_roundingmode_nearest_even(arg1_e);

  msat_make_fp_roundingmode_nearest_even_jretval = (jlong)((size_t)(msat_make_fp_roundingmode_nearest_even_retval.repr));

  return msat_make_fp_roundingmode_nearest_even_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1roundingmode_1zero
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_fp_roundingmode_zero_retval;
  jlong msat_make_fp_roundingmode_zero_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_fp_roundingmode_zero_retval = msat_make_fp_roundingmode_zero(arg1_e);

  msat_make_fp_roundingmode_zero_jretval = (jlong)((size_t)(msat_make_fp_roundingmode_zero_retval.repr));

  return msat_make_fp_roundingmode_zero_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1roundingmode_1plus_1inf
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_fp_roundingmode_plus_inf_retval;
  jlong msat_make_fp_roundingmode_plus_inf_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_fp_roundingmode_plus_inf_retval = msat_make_fp_roundingmode_plus_inf(arg1_e);

  msat_make_fp_roundingmode_plus_inf_jretval = (jlong)((size_t)(msat_make_fp_roundingmode_plus_inf_retval.repr));

  return msat_make_fp_roundingmode_plus_inf_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1roundingmode_1minus_1inf
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_fp_roundingmode_minus_inf_retval;
  jlong msat_make_fp_roundingmode_minus_inf_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_fp_roundingmode_minus_inf_retval = msat_make_fp_roundingmode_minus_inf(arg1_e);

  msat_make_fp_roundingmode_minus_inf_jretval = (jlong)((size_t)(msat_make_fp_roundingmode_minus_inf_retval.repr));

  return msat_make_fp_roundingmode_minus_inf_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1equal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_fp_equal_retval;
  jlong msat_make_fp_equal_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_fp_equal_retval = msat_make_fp_equal(arg1_e, arg2_t1, arg3_t2);

  msat_make_fp_equal_jretval = (jlong)((size_t)(msat_make_fp_equal_retval.repr));

  return msat_make_fp_equal_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1lt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_fp_lt_retval;
  jlong msat_make_fp_lt_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_fp_lt_retval = msat_make_fp_lt(arg1_e, arg2_t1, arg3_t2);

  msat_make_fp_lt_jretval = (jlong)((size_t)(msat_make_fp_lt_retval.repr));

  return msat_make_fp_lt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1leq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_fp_leq_retval;
  jlong msat_make_fp_leq_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_fp_leq_retval = msat_make_fp_leq(arg1_e, arg2_t1, arg3_t2);

  msat_make_fp_leq_jretval = (jlong)((size_t)(msat_make_fp_leq_retval.repr));

  return msat_make_fp_leq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1neg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_neg_retval;
  jlong msat_make_fp_neg_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_neg_retval = msat_make_fp_neg(arg1_e, arg2_t);

  msat_make_fp_neg_jretval = (jlong)((size_t)(msat_make_fp_neg_retval.repr));

  return msat_make_fp_neg_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  msat_term arg2_rounding;
  msat_term arg3_t1;
  msat_term arg4_t2;
  msat_term msat_make_fp_plus_retval;
  jlong msat_make_fp_plus_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_rounding.repr = (void *)((size_t)arg2);
arg3_t1.repr = (void *)((size_t)arg3);
arg4_t2.repr = (void *)((size_t)arg4);

  msat_make_fp_plus_retval = msat_make_fp_plus(arg1_e, arg2_rounding, arg3_t1, arg4_t2);

  msat_make_fp_plus_jretval = (jlong)((size_t)(msat_make_fp_plus_retval.repr));

  return msat_make_fp_plus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  msat_term arg2_rounding;
  msat_term arg3_t1;
  msat_term arg4_t2;
  msat_term msat_make_fp_minus_retval;
  jlong msat_make_fp_minus_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_rounding.repr = (void *)((size_t)arg2);
arg3_t1.repr = (void *)((size_t)arg3);
arg4_t2.repr = (void *)((size_t)arg4);

  msat_make_fp_minus_retval = msat_make_fp_minus(arg1_e, arg2_rounding, arg3_t1, arg4_t2);

  msat_make_fp_minus_jretval = (jlong)((size_t)(msat_make_fp_minus_retval.repr));

  return msat_make_fp_minus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  msat_term arg2_rounding;
  msat_term arg3_t1;
  msat_term arg4_t2;
  msat_term msat_make_fp_times_retval;
  jlong msat_make_fp_times_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_rounding.repr = (void *)((size_t)arg2);
arg3_t1.repr = (void *)((size_t)arg3);
arg4_t2.repr = (void *)((size_t)arg4);

  msat_make_fp_times_retval = msat_make_fp_times(arg1_e, arg2_rounding, arg3_t1, arg4_t2);

  msat_make_fp_times_jretval = (jlong)((size_t)(msat_make_fp_times_retval.repr));

  return msat_make_fp_times_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1div
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  msat_term arg2_rounding;
  msat_term arg3_t1;
  msat_term arg4_t2;
  msat_term msat_make_fp_div_retval;
  jlong msat_make_fp_div_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_rounding.repr = (void *)((size_t)arg2);
arg3_t1.repr = (void *)((size_t)arg3);
arg4_t2.repr = (void *)((size_t)arg4);

  msat_make_fp_div_retval = msat_make_fp_div(arg1_e, arg2_rounding, arg3_t1, arg4_t2);

  msat_make_fp_div_jretval = (jlong)((size_t)(msat_make_fp_div_retval.repr));

  return msat_make_fp_div_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1sqrt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_rounding;
  msat_term arg3_t;
  msat_term msat_make_fp_sqrt_retval;
  jlong msat_make_fp_sqrt_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_rounding.repr = (void *)((size_t)arg2);
arg3_t.repr = (void *)((size_t)arg3);

  msat_make_fp_sqrt_retval = msat_make_fp_sqrt(arg1_e, arg2_rounding, arg3_t);

  msat_make_fp_sqrt_jretval = (jlong)((size_t)(msat_make_fp_sqrt_retval.repr));

  return msat_make_fp_sqrt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1abs
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_abs_retval;
  jlong msat_make_fp_abs_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_abs_retval = msat_make_fp_abs(arg1_e, arg2_t);

  msat_make_fp_abs_jretval = (jlong)((size_t)(msat_make_fp_abs_retval.repr));

  return msat_make_fp_abs_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1min
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_fp_min_retval;
  jlong msat_make_fp_min_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_fp_min_retval = msat_make_fp_min(arg1_e, arg2_t1, arg3_t2);

  msat_make_fp_min_jretval = (jlong)((size_t)(msat_make_fp_min_retval.repr));

  return msat_make_fp_min_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1max
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_fp_max_retval;
  jlong msat_make_fp_max_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_fp_max_retval = msat_make_fp_max(arg1_e, arg2_t1, arg3_t2);

  msat_make_fp_max_jretval = (jlong)((size_t)(msat_make_fp_max_retval.repr));

  return msat_make_fp_max_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1round_1to_1int
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_rounding;
  msat_term arg3_t;
  msat_term msat_make_fp_round_to_int_retval;
  jlong msat_make_fp_round_to_int_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_rounding.repr = (void *)((size_t)arg2);
arg3_t.repr = (void *)((size_t)arg3);

  msat_make_fp_round_to_int_retval = msat_make_fp_round_to_int(arg1_e, arg2_rounding, arg3_t);

  msat_make_fp_round_to_int_jretval = (jlong)((size_t)(msat_make_fp_round_to_int_retval.repr));

  return msat_make_fp_round_to_int_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1cast
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3, jlong arg4, jlong arg5)
{
  msat_env arg1_e;
  size_t arg2_exp_w;
  size_t arg3_mant_w;
  msat_term arg4_rounding;
  msat_term arg5_t;
  msat_term msat_make_fp_cast_retval;
  jlong msat_make_fp_cast_jretval;
  
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_exp_w = arg2;
arg3_mant_w = arg3;
arg4_rounding.repr = (void *)((size_t)arg4);
arg5_t.repr = (void *)((size_t)arg5);

  msat_make_fp_cast_retval = msat_make_fp_cast(arg1_e, arg2_exp_w, arg3_mant_w, arg4_rounding, arg5_t);

  msat_make_fp_cast_jretval = (jlong)((size_t)(msat_make_fp_cast_retval.repr));

  return msat_make_fp_cast_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1to_1bv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  size_t arg2_width;
  msat_term arg3_rounding;
  msat_term arg4_t;
  msat_term msat_make_fp_to_bv_retval;
  jlong msat_make_fp_to_bv_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_width = arg2;
arg3_rounding.repr = (void *)((size_t)arg3);
arg4_t.repr = (void *)((size_t)arg4);

  msat_make_fp_to_bv_retval = msat_make_fp_to_bv(arg1_e, arg2_width, arg3_rounding, arg4_t);

  msat_make_fp_to_bv_jretval = (jlong)((size_t)(msat_make_fp_to_bv_retval.repr));

  return msat_make_fp_to_bv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1from_1sbv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3, jlong arg4, jlong arg5)
{
  msat_env arg1_e;
  size_t arg2_exp_w;
  size_t arg3_mant_w;
  msat_term arg4_rounding;
  msat_term arg5_t;
  msat_term msat_make_fp_from_sbv_retval;
  jlong msat_make_fp_from_sbv_jretval;
  
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_exp_w = arg2;
arg3_mant_w = arg3;
arg4_rounding.repr = (void *)((size_t)arg4);
arg5_t.repr = (void *)((size_t)arg5);

  msat_make_fp_from_sbv_retval = msat_make_fp_from_sbv(arg1_e, arg2_exp_w, arg3_mant_w, arg4_rounding, arg5_t);

  msat_make_fp_from_sbv_jretval = (jlong)((size_t)(msat_make_fp_from_sbv_retval.repr));

  return msat_make_fp_from_sbv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1from_1ubv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3, jlong arg4, jlong arg5)
{
  msat_env arg1_e;
  size_t arg2_exp_w;
  size_t arg3_mant_w;
  msat_term arg4_rounding;
  msat_term arg5_t;
  msat_term msat_make_fp_from_ubv_retval;
  jlong msat_make_fp_from_ubv_jretval;
  
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_exp_w = arg2;
arg3_mant_w = arg3;
arg4_rounding.repr = (void *)((size_t)arg4);
arg5_t.repr = (void *)((size_t)arg5);

  msat_make_fp_from_ubv_retval = msat_make_fp_from_ubv(arg1_e, arg2_exp_w, arg3_mant_w, arg4_rounding, arg5_t);

  msat_make_fp_from_ubv_jretval = (jlong)((size_t)(msat_make_fp_from_ubv_retval.repr));

  return msat_make_fp_from_ubv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1as_1ieeebv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_as_ieeebv_retval;
  jlong msat_make_fp_as_ieeebv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_as_ieeebv_retval = msat_make_fp_as_ieeebv(arg1_e, arg2_t);

  msat_make_fp_as_ieeebv_jretval = (jlong)((size_t)(msat_make_fp_as_ieeebv_retval.repr));

  return msat_make_fp_as_ieeebv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1from_1ieeebv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3, jlong arg4)
{
  msat_env arg1_e;
  size_t arg2_exp_w;
  size_t arg3_mant_w;
  msat_term arg4_t;
  msat_term msat_make_fp_from_ieeebv_retval;
  jlong msat_make_fp_from_ieeebv_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_exp_w = arg2;
arg3_mant_w = arg3;
arg4_t.repr = (void *)((size_t)arg4);

  msat_make_fp_from_ieeebv_retval = msat_make_fp_from_ieeebv(arg1_e, arg2_exp_w, arg3_mant_w, arg4_t);

  msat_make_fp_from_ieeebv_jretval = (jlong)((size_t)(msat_make_fp_from_ieeebv_retval.repr));

  return msat_make_fp_from_ieeebv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1isnan
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_isnan_retval;
  jlong msat_make_fp_isnan_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_isnan_retval = msat_make_fp_isnan(arg1_e, arg2_t);

  msat_make_fp_isnan_jretval = (jlong)((size_t)(msat_make_fp_isnan_retval.repr));

  return msat_make_fp_isnan_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1isinf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_isinf_retval;
  jlong msat_make_fp_isinf_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_isinf_retval = msat_make_fp_isinf(arg1_e, arg2_t);

  msat_make_fp_isinf_jretval = (jlong)((size_t)(msat_make_fp_isinf_retval.repr));

  return msat_make_fp_isinf_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1iszero
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_iszero_retval;
  jlong msat_make_fp_iszero_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_iszero_retval = msat_make_fp_iszero(arg1_e, arg2_t);

  msat_make_fp_iszero_jretval = (jlong)((size_t)(msat_make_fp_iszero_retval.repr));

  return msat_make_fp_iszero_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1issubnormal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_issubnormal_retval;
  jlong msat_make_fp_issubnormal_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_issubnormal_retval = msat_make_fp_issubnormal(arg1_e, arg2_t);

  msat_make_fp_issubnormal_jretval = (jlong)((size_t)(msat_make_fp_issubnormal_retval.repr));

  return msat_make_fp_issubnormal_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1isnormal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_isnormal_retval;
  jlong msat_make_fp_isnormal_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_isnormal_retval = msat_make_fp_isnormal(arg1_e, arg2_t);

  msat_make_fp_isnormal_jretval = (jlong)((size_t)(msat_make_fp_isnormal_retval.repr));

  return msat_make_fp_isnormal_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1isneg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_isneg_retval;
  jlong msat_make_fp_isneg_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_isneg_retval = msat_make_fp_isneg(arg1_e, arg2_t);

  msat_make_fp_isneg_jretval = (jlong)((size_t)(msat_make_fp_isneg_retval.repr));

  return msat_make_fp_isneg_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1ispos
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_fp_ispos_retval;
  jlong msat_make_fp_ispos_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_fp_ispos_retval = msat_make_fp_ispos(arg1_e, arg2_t);

  msat_make_fp_ispos_jretval = (jlong)((size_t)(msat_make_fp_ispos_retval.repr));

  return msat_make_fp_ispos_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1plus_1inf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3)
{
  msat_env arg1_e;
  size_t arg2_exp_w;
  size_t arg3_mant_w;
  msat_term msat_make_fp_plus_inf_retval;
  jlong msat_make_fp_plus_inf_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_exp_w = arg2;
arg3_mant_w = arg3;

  msat_make_fp_plus_inf_retval = msat_make_fp_plus_inf(arg1_e, arg2_exp_w, arg3_mant_w);

  msat_make_fp_plus_inf_jretval = (jlong)((size_t)(msat_make_fp_plus_inf_retval.repr));

  return msat_make_fp_plus_inf_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1minus_1inf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3)
{
  msat_env arg1_e;
  size_t arg2_exp_w;
  size_t arg3_mant_w;
  msat_term msat_make_fp_minus_inf_retval;
  jlong msat_make_fp_minus_inf_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_exp_w = arg2;
arg3_mant_w = arg3;

  msat_make_fp_minus_inf_retval = msat_make_fp_minus_inf(arg1_e, arg2_exp_w, arg3_mant_w);

  msat_make_fp_minus_inf_jretval = (jlong)((size_t)(msat_make_fp_minus_inf_retval.repr));

  return msat_make_fp_minus_inf_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1nan
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jint arg3)
{
  msat_env arg1_e;
  size_t arg2_exp_w;
  size_t arg3_mant_w;
  msat_term msat_make_fp_nan_retval;
  jlong msat_make_fp_nan_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_exp_w = arg2;
arg3_mant_w = arg3;

  msat_make_fp_nan_retval = msat_make_fp_nan(arg1_e, arg2_exp_w, arg3_mant_w);

  msat_make_fp_nan_jretval = (jlong)((size_t)(msat_make_fp_nan_retval.repr));

  return msat_make_fp_nan_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1rat_1number
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jint arg3, jint arg4, jlong arg5)
{
  msat_env arg1_e;
  char * arg2_num_rep;
  size_t arg3_exp_w;
  size_t arg4_mant_w;
  msat_term arg5_rounding;
  msat_term msat_make_fp_rat_number_retval;
  jlong msat_make_fp_rat_number_jretval;
  
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_num_rep = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
arg3_exp_w = arg3;
arg4_mant_w = arg4;
arg5_rounding.repr = (void *)((size_t)arg5);

  msat_make_fp_rat_number_retval = msat_make_fp_rat_number(arg1_e, arg2_num_rep, arg3_exp_w, arg4_mant_w, arg5_rounding);

  msat_make_fp_rat_number_jretval = (jlong)((size_t)(msat_make_fp_rat_number_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_num_rep);

  return msat_make_fp_rat_number_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1fp_1bits_1number
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jint arg3, jint arg4)
{
  msat_env arg1_e;
  char * arg2_bits;
  size_t arg3_exp_w;
  size_t arg4_mant_w;
  msat_term msat_make_fp_bits_number_retval;
  jlong msat_make_fp_bits_number_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_bits = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
arg3_exp_w = arg3;
arg4_mant_w = arg4;

  msat_make_fp_bits_number_retval = msat_make_fp_bits_number(arg1_e, arg2_bits, arg3_exp_w, arg4_mant_w);

  msat_make_fp_bits_number_jretval = (jlong)((size_t)(msat_make_fp_bits_number_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_bits);

  return msat_make_fp_bits_number_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1int_1to_1bv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlong arg3)
{
  msat_env arg1_e;
  size_t arg2_width;
  msat_term arg3_t;
  msat_term msat_make_int_to_bv_retval;
  jlong msat_make_int_to_bv_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_width = arg2;
arg3_t.repr = (void *)((size_t)arg3);

  msat_make_int_to_bv_retval = msat_make_int_to_bv(arg1_e, arg2_width, arg3_t);

  msat_make_int_to_bv_jretval = (jlong)((size_t)(msat_make_int_to_bv_retval.repr));

  return msat_make_int_to_bv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1int_1from_1ubv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_int_from_ubv_retval;
  jlong msat_make_int_from_ubv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_int_from_ubv_retval = msat_make_int_from_ubv(arg1_e, arg2_t);

  msat_make_int_from_ubv_jretval = (jlong)((size_t)(msat_make_int_from_ubv_retval.repr));

  return msat_make_int_from_ubv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1int_1from_1sbv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_int_from_sbv_retval;
  jlong msat_make_int_from_sbv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_int_from_sbv_retval = msat_make_int_from_sbv(arg1_e, arg2_t);

  msat_make_int_from_sbv_jretval = (jlong)((size_t)(msat_make_int_from_sbv_retval.repr));

  return msat_make_int_from_sbv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1term
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3)
{
  msat_env arg1_e;
  msat_decl arg2_d;
  msat_term * arg3_args;
  msat_term msat_make_term_retval;
  jlong msat_make_term_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_d.repr = (void *)((size_t)arg2);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg3, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg3));
  arg3_args = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg3_args[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg3, tmp, 0);
}


  msat_make_term_retval = msat_make_term(arg1_e, arg2_d, arg3_args);

  msat_make_term_jretval = (jlong)((size_t)(msat_make_term_retval.repr));
free(arg3_args);

  return msat_make_term_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1copy_1from
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_env arg3_src;
  msat_term msat_make_copy_from_retval;
  jlong msat_make_copy_from_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
arg3_src.repr = (void *)((size_t)arg3);

  msat_make_copy_from_retval = msat_make_copy_from(arg1_e, arg2_t, arg3_src);

  msat_make_copy_from_jretval = (jlong)((size_t)(msat_make_copy_from_retval.repr));

  return msat_make_copy_from_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1id
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  size_t msat_term_id_retval;
  jint msat_term_id_jretval;
  

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_id_retval = msat_term_id(arg1_t);

  msat_term_id_jretval = (jint)msat_term_id_retval;

  return msat_term_id_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1arity
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  size_t msat_term_arity_retval;
  jint msat_term_arity_jretval;
  

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_arity_retval = msat_term_arity(arg1_t);

  msat_term_arity_jretval = (jint)msat_term_arity_retval;

  return msat_term_arity_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1term_1get_1arg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_term arg1_t;
  size_t arg2_n;
  msat_term msat_term_get_arg_retval;
  jlong msat_term_get_arg_jretval;
  
  

arg1_t.repr = (void *)((size_t)arg1);
arg2_n = arg2;

  msat_term_get_arg_retval = msat_term_get_arg(arg1_t, arg2_n);

  msat_term_get_arg_jretval = (jlong)((size_t)(msat_term_get_arg_retval.repr));

  return msat_term_get_arg_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1term_1get_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  msat_type msat_term_get_type_retval;
  jlong msat_term_get_type_jretval;
  

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_get_type_retval = msat_term_get_type(arg1_t);

  msat_term_get_type_jretval = (jlong)((size_t)(msat_term_get_type_retval.repr));

  return msat_term_get_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1true
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_true_retval;
  jint msat_term_is_true_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_true_retval = msat_term_is_true(arg1_e, arg2_t);

  msat_term_is_true_jretval = (jint)msat_term_is_true_retval;

  return msat_term_is_true_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1false
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_false_retval;
  jint msat_term_is_false_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_false_retval = msat_term_is_false(arg1_e, arg2_t);

  msat_term_is_false_jretval = (jint)msat_term_is_false_retval;

  return msat_term_is_false_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1boolean_1constant
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_boolean_constant_retval;
  jint msat_term_is_boolean_constant_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_boolean_constant_retval = msat_term_is_boolean_constant(arg1_e, arg2_t);

  msat_term_is_boolean_constant_jretval = (jint)msat_term_is_boolean_constant_retval;

  return msat_term_is_boolean_constant_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1atom
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_atom_retval;
  jint msat_term_is_atom_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_atom_retval = msat_term_is_atom(arg1_e, arg2_t);

  msat_term_is_atom_jretval = (jint)msat_term_is_atom_retval;

  return msat_term_is_atom_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1number
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_number_retval;
  jint msat_term_is_number_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_number_retval = msat_term_is_number(arg1_e, arg2_t);

  msat_term_is_number_jretval = (jint)msat_term_is_number_retval;

  return msat_term_is_number_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_and_retval;
  jint msat_term_is_and_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_and_retval = msat_term_is_and(arg1_e, arg2_t);

  msat_term_is_and_jretval = (jint)msat_term_is_and_retval;

  return msat_term_is_and_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_or_retval;
  jint msat_term_is_or_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_or_retval = msat_term_is_or(arg1_e, arg2_t);

  msat_term_is_or_jretval = (jint)msat_term_is_or_retval;

  return msat_term_is_or_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_not_retval;
  jint msat_term_is_not_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_not_retval = msat_term_is_not(arg1_e, arg2_t);

  msat_term_is_not_jretval = (jint)msat_term_is_not_retval;

  return msat_term_is_not_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1iff
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_iff_retval;
  jint msat_term_is_iff_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_iff_retval = msat_term_is_iff(arg1_e, arg2_t);

  msat_term_is_iff_jretval = (jint)msat_term_is_iff_retval;

  return msat_term_is_iff_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1term_1ite
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_term_ite_retval;
  jint msat_term_is_term_ite_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_term_ite_retval = msat_term_is_term_ite(arg1_e, arg2_t);

  msat_term_is_term_ite_jretval = (jint)msat_term_is_term_ite_retval;

  return msat_term_is_term_ite_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1constant
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_constant_retval;
  jint msat_term_is_constant_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_constant_retval = msat_term_is_constant(arg1_e, arg2_t);

  msat_term_is_constant_jretval = (jint)msat_term_is_constant_retval;

  return msat_term_is_constant_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1uf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_uf_retval;
  jint msat_term_is_uf_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_uf_retval = msat_term_is_uf(arg1_e, arg2_t);

  msat_term_is_uf_jretval = (jint)msat_term_is_uf_retval;

  return msat_term_is_uf_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1equal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_equal_retval;
  jint msat_term_is_equal_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_equal_retval = msat_term_is_equal(arg1_e, arg2_t);

  msat_term_is_equal_jretval = (jint)msat_term_is_equal_retval;

  return msat_term_is_equal_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1leq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_leq_retval;
  jint msat_term_is_leq_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_leq_retval = msat_term_is_leq(arg1_e, arg2_t);

  msat_term_is_leq_jretval = (jint)msat_term_is_leq_retval;

  return msat_term_is_leq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_plus_retval;
  jint msat_term_is_plus_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_plus_retval = msat_term_is_plus(arg1_e, arg2_t);

  msat_term_is_plus_jretval = (jint)msat_term_is_plus_retval;

  return msat_term_is_plus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_times_retval;
  jint msat_term_is_times_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_times_retval = msat_term_is_times(arg1_e, arg2_t);

  msat_term_is_times_jretval = (jint)msat_term_is_times_retval;

  return msat_term_is_times_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1divide
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_divide_retval;
  jint msat_term_is_divide_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_divide_retval = msat_term_is_divide(arg1_e, arg2_t);

  msat_term_is_divide_jretval = (jint)msat_term_is_divide_retval;

  return msat_term_is_divide_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1int_1modular_1congruence
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jobjectArray arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  mpz_t arg3_out_mod;
  int msat_term_is_int_modular_congruence_retval;
  jint msat_term_is_int_modular_congruence_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
mpz_init(arg3_out_mod);

  msat_term_is_int_modular_congruence_retval = msat_term_is_int_modular_congruence(arg1_e, arg2_t, arg3_out_mod);

  msat_term_is_int_modular_congruence_jretval = (jint)msat_term_is_int_modular_congruence_retval;
{
char *s = mpz_get_str(NULL, 10, arg3_out_mod);
jstring tmp = (*jenv)->NewStringUTF(jenv, s);
free(s);
(*jenv)->SetObjectArrayElement(jenv, arg3, 0, tmp);
}
mpz_clear(arg3_out_mod);


  return msat_term_is_int_modular_congruence_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1floor
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_floor_retval;
  jint msat_term_is_floor_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_floor_retval = msat_term_is_floor(arg1_e, arg2_t);

  msat_term_is_floor_jretval = (jint)msat_term_is_floor_retval;

  return msat_term_is_floor_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1array_1read
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_array_read_retval;
  jint msat_term_is_array_read_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_array_read_retval = msat_term_is_array_read(arg1_e, arg2_t);

  msat_term_is_array_read_jretval = (jint)msat_term_is_array_read_retval;

  return msat_term_is_array_read_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1array_1write
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_array_write_retval;
  jint msat_term_is_array_write_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_array_write_retval = msat_term_is_array_write(arg1_e, arg2_t);

  msat_term_is_array_write_jretval = (jint)msat_term_is_array_write_retval;

  return msat_term_is_array_write_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1array_1const
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_array_const_retval;
  jint msat_term_is_array_const_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_array_const_retval = msat_term_is_array_const(arg1_e, arg2_t);

  msat_term_is_array_const_jretval = (jint)msat_term_is_array_const_retval;

  return msat_term_is_array_const_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1concat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_concat_retval;
  jint msat_term_is_bv_concat_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_concat_retval = msat_term_is_bv_concat(arg1_e, arg2_t);

  msat_term_is_bv_concat_jretval = (jint)msat_term_is_bv_concat_retval;

  return msat_term_is_bv_concat_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1extract
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jintArray arg3, jintArray arg4)
{
  msat_env arg1_e;
  msat_term arg2_t;
  size_t * arg3_out_msb;
  size_t * arg4_out_lsb;
  int msat_term_is_bv_extract_retval;
  jint msat_term_is_bv_extract_jretval;
  
  
  size_t ptrarg3_out_msb;
  size_t ptrarg4_out_lsb;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
/*size_t ptrarg3_out_msb;*/
arg3_out_msb = &ptrarg3_out_msb;

/*size_t ptrarg4_out_lsb;*/
arg4_out_lsb = &ptrarg4_out_lsb;


  msat_term_is_bv_extract_retval = msat_term_is_bv_extract(arg1_e, arg2_t, arg3_out_msb, arg4_out_lsb);

  msat_term_is_bv_extract_jretval = (jint)msat_term_is_bv_extract_retval;
(*jenv)->SetIntArrayRegion(jenv, arg4, 0, 1, (jint *)&(ptrarg4_out_lsb));

(*jenv)->SetIntArrayRegion(jenv, arg3, 0, 1, (jint *)&(ptrarg3_out_msb));


  return msat_term_is_bv_extract_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_or_retval;
  jint msat_term_is_bv_or_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_or_retval = msat_term_is_bv_or(arg1_e, arg2_t);

  msat_term_is_bv_or_jretval = (jint)msat_term_is_bv_or_retval;

  return msat_term_is_bv_or_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1xor
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_xor_retval;
  jint msat_term_is_bv_xor_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_xor_retval = msat_term_is_bv_xor(arg1_e, arg2_t);

  msat_term_is_bv_xor_jretval = (jint)msat_term_is_bv_xor_retval;

  return msat_term_is_bv_xor_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_and_retval;
  jint msat_term_is_bv_and_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_and_retval = msat_term_is_bv_and(arg1_e, arg2_t);

  msat_term_is_bv_and_jretval = (jint)msat_term_is_bv_and_retval;

  return msat_term_is_bv_and_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_not_retval;
  jint msat_term_is_bv_not_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_not_retval = msat_term_is_bv_not(arg1_e, arg2_t);

  msat_term_is_bv_not_jretval = (jint)msat_term_is_bv_not_retval;

  return msat_term_is_bv_not_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_plus_retval;
  jint msat_term_is_bv_plus_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_plus_retval = msat_term_is_bv_plus(arg1_e, arg2_t);

  msat_term_is_bv_plus_jretval = (jint)msat_term_is_bv_plus_retval;

  return msat_term_is_bv_plus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_minus_retval;
  jint msat_term_is_bv_minus_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_minus_retval = msat_term_is_bv_minus(arg1_e, arg2_t);

  msat_term_is_bv_minus_jretval = (jint)msat_term_is_bv_minus_retval;

  return msat_term_is_bv_minus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_times_retval;
  jint msat_term_is_bv_times_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_times_retval = msat_term_is_bv_times(arg1_e, arg2_t);

  msat_term_is_bv_times_jretval = (jint)msat_term_is_bv_times_retval;

  return msat_term_is_bv_times_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1neg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_neg_retval;
  jint msat_term_is_bv_neg_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_neg_retval = msat_term_is_bv_neg(arg1_e, arg2_t);

  msat_term_is_bv_neg_jretval = (jint)msat_term_is_bv_neg_retval;

  return msat_term_is_bv_neg_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1udiv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_udiv_retval;
  jint msat_term_is_bv_udiv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_udiv_retval = msat_term_is_bv_udiv(arg1_e, arg2_t);

  msat_term_is_bv_udiv_jretval = (jint)msat_term_is_bv_udiv_retval;

  return msat_term_is_bv_udiv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1urem
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_urem_retval;
  jint msat_term_is_bv_urem_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_urem_retval = msat_term_is_bv_urem(arg1_e, arg2_t);

  msat_term_is_bv_urem_jretval = (jint)msat_term_is_bv_urem_retval;

  return msat_term_is_bv_urem_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sdiv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_sdiv_retval;
  jint msat_term_is_bv_sdiv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_sdiv_retval = msat_term_is_bv_sdiv(arg1_e, arg2_t);

  msat_term_is_bv_sdiv_jretval = (jint)msat_term_is_bv_sdiv_retval;

  return msat_term_is_bv_sdiv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1srem
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_srem_retval;
  jint msat_term_is_bv_srem_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_srem_retval = msat_term_is_bv_srem(arg1_e, arg2_t);

  msat_term_is_bv_srem_jretval = (jint)msat_term_is_bv_srem_retval;

  return msat_term_is_bv_srem_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1ult
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_ult_retval;
  jint msat_term_is_bv_ult_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_ult_retval = msat_term_is_bv_ult(arg1_e, arg2_t);

  msat_term_is_bv_ult_jretval = (jint)msat_term_is_bv_ult_retval;

  return msat_term_is_bv_ult_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1uleq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_uleq_retval;
  jint msat_term_is_bv_uleq_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_uleq_retval = msat_term_is_bv_uleq(arg1_e, arg2_t);

  msat_term_is_bv_uleq_jretval = (jint)msat_term_is_bv_uleq_retval;

  return msat_term_is_bv_uleq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1slt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_slt_retval;
  jint msat_term_is_bv_slt_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_slt_retval = msat_term_is_bv_slt(arg1_e, arg2_t);

  msat_term_is_bv_slt_jretval = (jint)msat_term_is_bv_slt_retval;

  return msat_term_is_bv_slt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sleq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_sleq_retval;
  jint msat_term_is_bv_sleq_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_sleq_retval = msat_term_is_bv_sleq(arg1_e, arg2_t);

  msat_term_is_bv_sleq_jretval = (jint)msat_term_is_bv_sleq_retval;

  return msat_term_is_bv_sleq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1lshl
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_lshl_retval;
  jint msat_term_is_bv_lshl_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_lshl_retval = msat_term_is_bv_lshl(arg1_e, arg2_t);

  msat_term_is_bv_lshl_jretval = (jint)msat_term_is_bv_lshl_retval;

  return msat_term_is_bv_lshl_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1lshr
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_lshr_retval;
  jint msat_term_is_bv_lshr_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_lshr_retval = msat_term_is_bv_lshr(arg1_e, arg2_t);

  msat_term_is_bv_lshr_jretval = (jint)msat_term_is_bv_lshr_retval;

  return msat_term_is_bv_lshr_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1ashr
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_ashr_retval;
  jint msat_term_is_bv_ashr_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_ashr_retval = msat_term_is_bv_ashr(arg1_e, arg2_t);

  msat_term_is_bv_ashr_jretval = (jint)msat_term_is_bv_ashr_retval;

  return msat_term_is_bv_ashr_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1zext
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jintArray arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  size_t * arg3_out_amount;
  int msat_term_is_bv_zext_retval;
  jint msat_term_is_bv_zext_jretval;
  
  
  size_t ptrarg3_out_amount;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
/*size_t ptrarg3_out_amount;*/
arg3_out_amount = &ptrarg3_out_amount;


  msat_term_is_bv_zext_retval = msat_term_is_bv_zext(arg1_e, arg2_t, arg3_out_amount);

  msat_term_is_bv_zext_jretval = (jint)msat_term_is_bv_zext_retval;
(*jenv)->SetIntArrayRegion(jenv, arg3, 0, 1, (jint *)&(ptrarg3_out_amount));


  return msat_term_is_bv_zext_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sext
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jintArray arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  size_t * arg3_out_amount;
  int msat_term_is_bv_sext_retval;
  jint msat_term_is_bv_sext_jretval;
  
  
  size_t ptrarg3_out_amount;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
/*size_t ptrarg3_out_amount;*/
arg3_out_amount = &ptrarg3_out_amount;


  msat_term_is_bv_sext_retval = msat_term_is_bv_sext(arg1_e, arg2_t, arg3_out_amount);

  msat_term_is_bv_sext_jretval = (jint)msat_term_is_bv_sext_retval;
(*jenv)->SetIntArrayRegion(jenv, arg3, 0, 1, (jint *)&(ptrarg3_out_amount));


  return msat_term_is_bv_sext_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1rol
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jintArray arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  size_t * arg3_out_amount;
  int msat_term_is_bv_rol_retval;
  jint msat_term_is_bv_rol_jretval;
  
  
  size_t ptrarg3_out_amount;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
/*size_t ptrarg3_out_amount;*/
arg3_out_amount = &ptrarg3_out_amount;


  msat_term_is_bv_rol_retval = msat_term_is_bv_rol(arg1_e, arg2_t, arg3_out_amount);

  msat_term_is_bv_rol_jretval = (jint)msat_term_is_bv_rol_retval;
(*jenv)->SetIntArrayRegion(jenv, arg3, 0, 1, (jint *)&(ptrarg3_out_amount));


  return msat_term_is_bv_rol_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1ror
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jintArray arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  size_t * arg3_out_amount;
  int msat_term_is_bv_ror_retval;
  jint msat_term_is_bv_ror_jretval;
  
  
  size_t ptrarg3_out_amount;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
/*size_t ptrarg3_out_amount;*/
arg3_out_amount = &ptrarg3_out_amount;


  msat_term_is_bv_ror_retval = msat_term_is_bv_ror(arg1_e, arg2_t, arg3_out_amount);

  msat_term_is_bv_ror_jretval = (jint)msat_term_is_bv_ror_retval;
(*jenv)->SetIntArrayRegion(jenv, arg3, 0, 1, (jint *)&(ptrarg3_out_amount));


  return msat_term_is_bv_ror_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1comp
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_bv_comp_retval;
  jint msat_term_is_bv_comp_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_bv_comp_retval = msat_term_is_bv_comp(arg1_e, arg2_t);

  msat_term_is_bv_comp_jretval = (jint)msat_term_is_bv_comp_retval;

  return msat_term_is_bv_comp_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1roundingmode_1nearest_1even
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_roundingmode_nearest_even_retval;
  jint msat_term_is_fp_roundingmode_nearest_even_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_roundingmode_nearest_even_retval = msat_term_is_fp_roundingmode_nearest_even(arg1_e, arg2_t);

  msat_term_is_fp_roundingmode_nearest_even_jretval = (jint)msat_term_is_fp_roundingmode_nearest_even_retval;

  return msat_term_is_fp_roundingmode_nearest_even_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1roundingmode_1zero
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_roundingmode_zero_retval;
  jint msat_term_is_fp_roundingmode_zero_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_roundingmode_zero_retval = msat_term_is_fp_roundingmode_zero(arg1_e, arg2_t);

  msat_term_is_fp_roundingmode_zero_jretval = (jint)msat_term_is_fp_roundingmode_zero_retval;

  return msat_term_is_fp_roundingmode_zero_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1roundingmode_1plus_1inf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_roundingmode_plus_inf_retval;
  jint msat_term_is_fp_roundingmode_plus_inf_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_roundingmode_plus_inf_retval = msat_term_is_fp_roundingmode_plus_inf(arg1_e, arg2_t);

  msat_term_is_fp_roundingmode_plus_inf_jretval = (jint)msat_term_is_fp_roundingmode_plus_inf_retval;

  return msat_term_is_fp_roundingmode_plus_inf_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1roundingmode_1minus_1inf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_roundingmode_minus_inf_retval;
  jint msat_term_is_fp_roundingmode_minus_inf_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_roundingmode_minus_inf_retval = msat_term_is_fp_roundingmode_minus_inf(arg1_e, arg2_t);

  msat_term_is_fp_roundingmode_minus_inf_jretval = (jint)msat_term_is_fp_roundingmode_minus_inf_retval;

  return msat_term_is_fp_roundingmode_minus_inf_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1equal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_equal_retval;
  jint msat_term_is_fp_equal_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_equal_retval = msat_term_is_fp_equal(arg1_e, arg2_t);

  msat_term_is_fp_equal_jretval = (jint)msat_term_is_fp_equal_retval;

  return msat_term_is_fp_equal_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1lt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_lt_retval;
  jint msat_term_is_fp_lt_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_lt_retval = msat_term_is_fp_lt(arg1_e, arg2_t);

  msat_term_is_fp_lt_jretval = (jint)msat_term_is_fp_lt_retval;

  return msat_term_is_fp_lt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1leq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_leq_retval;
  jint msat_term_is_fp_leq_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_leq_retval = msat_term_is_fp_leq(arg1_e, arg2_t);

  msat_term_is_fp_leq_jretval = (jint)msat_term_is_fp_leq_retval;

  return msat_term_is_fp_leq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1neg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_neg_retval;
  jint msat_term_is_fp_neg_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_neg_retval = msat_term_is_fp_neg(arg1_e, arg2_t);

  msat_term_is_fp_neg_jretval = (jint)msat_term_is_fp_neg_retval;

  return msat_term_is_fp_neg_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_plus_retval;
  jint msat_term_is_fp_plus_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_plus_retval = msat_term_is_fp_plus(arg1_e, arg2_t);

  msat_term_is_fp_plus_jretval = (jint)msat_term_is_fp_plus_retval;

  return msat_term_is_fp_plus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_minus_retval;
  jint msat_term_is_fp_minus_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_minus_retval = msat_term_is_fp_minus(arg1_e, arg2_t);

  msat_term_is_fp_minus_jretval = (jint)msat_term_is_fp_minus_retval;

  return msat_term_is_fp_minus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_times_retval;
  jint msat_term_is_fp_times_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_times_retval = msat_term_is_fp_times(arg1_e, arg2_t);

  msat_term_is_fp_times_jretval = (jint)msat_term_is_fp_times_retval;

  return msat_term_is_fp_times_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1div
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_div_retval;
  jint msat_term_is_fp_div_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_div_retval = msat_term_is_fp_div(arg1_e, arg2_t);

  msat_term_is_fp_div_jretval = (jint)msat_term_is_fp_div_retval;

  return msat_term_is_fp_div_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1sqrt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_sqrt_retval;
  jint msat_term_is_fp_sqrt_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_sqrt_retval = msat_term_is_fp_sqrt(arg1_e, arg2_t);

  msat_term_is_fp_sqrt_jretval = (jint)msat_term_is_fp_sqrt_retval;

  return msat_term_is_fp_sqrt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1abs
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_abs_retval;
  jint msat_term_is_fp_abs_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_abs_retval = msat_term_is_fp_abs(arg1_e, arg2_t);

  msat_term_is_fp_abs_jretval = (jint)msat_term_is_fp_abs_retval;

  return msat_term_is_fp_abs_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1min
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_min_retval;
  jint msat_term_is_fp_min_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_min_retval = msat_term_is_fp_min(arg1_e, arg2_t);

  msat_term_is_fp_min_jretval = (jint)msat_term_is_fp_min_retval;

  return msat_term_is_fp_min_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1max
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_max_retval;
  jint msat_term_is_fp_max_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_max_retval = msat_term_is_fp_max(arg1_e, arg2_t);

  msat_term_is_fp_max_jretval = (jint)msat_term_is_fp_max_retval;

  return msat_term_is_fp_max_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1round_1to_1int
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_round_to_int_retval;
  jint msat_term_is_fp_round_to_int_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_round_to_int_retval = msat_term_is_fp_round_to_int(arg1_e, arg2_t);

  msat_term_is_fp_round_to_int_jretval = (jint)msat_term_is_fp_round_to_int_retval;

  return msat_term_is_fp_round_to_int_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1cast
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_cast_retval;
  jint msat_term_is_fp_cast_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_cast_retval = msat_term_is_fp_cast(arg1_e, arg2_t);

  msat_term_is_fp_cast_jretval = (jint)msat_term_is_fp_cast_retval;

  return msat_term_is_fp_cast_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1to_1bv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_to_bv_retval;
  jint msat_term_is_fp_to_bv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_to_bv_retval = msat_term_is_fp_to_bv(arg1_e, arg2_t);

  msat_term_is_fp_to_bv_jretval = (jint)msat_term_is_fp_to_bv_retval;

  return msat_term_is_fp_to_bv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1from_1sbv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_from_sbv_retval;
  jint msat_term_is_fp_from_sbv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_from_sbv_retval = msat_term_is_fp_from_sbv(arg1_e, arg2_t);

  msat_term_is_fp_from_sbv_jretval = (jint)msat_term_is_fp_from_sbv_retval;

  return msat_term_is_fp_from_sbv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1from_1ubv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_from_ubv_retval;
  jint msat_term_is_fp_from_ubv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_from_ubv_retval = msat_term_is_fp_from_ubv(arg1_e, arg2_t);

  msat_term_is_fp_from_ubv_jretval = (jint)msat_term_is_fp_from_ubv_retval;

  return msat_term_is_fp_from_ubv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1as_1ieeebv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_as_ieeebv_retval;
  jint msat_term_is_fp_as_ieeebv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_as_ieeebv_retval = msat_term_is_fp_as_ieeebv(arg1_e, arg2_t);

  msat_term_is_fp_as_ieeebv_jretval = (jint)msat_term_is_fp_as_ieeebv_retval;

  return msat_term_is_fp_as_ieeebv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1from_1ieeebv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_from_ieeebv_retval;
  jint msat_term_is_fp_from_ieeebv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_from_ieeebv_retval = msat_term_is_fp_from_ieeebv(arg1_e, arg2_t);

  msat_term_is_fp_from_ieeebv_jretval = (jint)msat_term_is_fp_from_ieeebv_retval;

  return msat_term_is_fp_from_ieeebv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1isnan
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_isnan_retval;
  jint msat_term_is_fp_isnan_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_isnan_retval = msat_term_is_fp_isnan(arg1_e, arg2_t);

  msat_term_is_fp_isnan_jretval = (jint)msat_term_is_fp_isnan_retval;

  return msat_term_is_fp_isnan_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1isinf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_isinf_retval;
  jint msat_term_is_fp_isinf_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_isinf_retval = msat_term_is_fp_isinf(arg1_e, arg2_t);

  msat_term_is_fp_isinf_jretval = (jint)msat_term_is_fp_isinf_retval;

  return msat_term_is_fp_isinf_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1iszero
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_iszero_retval;
  jint msat_term_is_fp_iszero_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_iszero_retval = msat_term_is_fp_iszero(arg1_e, arg2_t);

  msat_term_is_fp_iszero_jretval = (jint)msat_term_is_fp_iszero_retval;

  return msat_term_is_fp_iszero_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1issubnormal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_issubnormal_retval;
  jint msat_term_is_fp_issubnormal_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_issubnormal_retval = msat_term_is_fp_issubnormal(arg1_e, arg2_t);

  msat_term_is_fp_issubnormal_jretval = (jint)msat_term_is_fp_issubnormal_retval;

  return msat_term_is_fp_issubnormal_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1isnormal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_isnormal_retval;
  jint msat_term_is_fp_isnormal_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_isnormal_retval = msat_term_is_fp_isnormal(arg1_e, arg2_t);

  msat_term_is_fp_isnormal_jretval = (jint)msat_term_is_fp_isnormal_retval;

  return msat_term_is_fp_isnormal_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1isneg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_isneg_retval;
  jint msat_term_is_fp_isneg_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_isneg_retval = msat_term_is_fp_isneg(arg1_e, arg2_t);

  msat_term_is_fp_isneg_jretval = (jint)msat_term_is_fp_isneg_retval;

  return msat_term_is_fp_isneg_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1fp_1ispos
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_fp_ispos_retval;
  jint msat_term_is_fp_ispos_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_fp_ispos_retval = msat_term_is_fp_ispos(arg1_e, arg2_t);

  msat_term_is_fp_ispos_jretval = (jint)msat_term_is_fp_ispos_retval;

  return msat_term_is_fp_ispos_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1int_1to_1bv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_int_to_bv_retval;
  jint msat_term_is_int_to_bv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_int_to_bv_retval = msat_term_is_int_to_bv(arg1_e, arg2_t);

  msat_term_is_int_to_bv_jretval = (jint)msat_term_is_int_to_bv_retval;

  return msat_term_is_int_to_bv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1int_1from_1ubv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_int_from_ubv_retval;
  jint msat_term_is_int_from_ubv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_int_from_ubv_retval = msat_term_is_int_from_ubv(arg1_e, arg2_t);

  msat_term_is_int_from_ubv_jretval = (jint)msat_term_is_int_from_ubv_retval;

  return msat_term_is_int_from_ubv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1int_1from_1sbv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  int msat_term_is_int_from_sbv_retval;
  jint msat_term_is_int_from_sbv_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_is_int_from_sbv_retval = msat_term_is_int_from_sbv(arg1_e, arg2_t);

  msat_term_is_int_from_sbv_jretval = (jint)msat_term_is_int_from_sbv_retval;

  return msat_term_is_int_from_sbv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1visit_1term
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jobject arg3, jint arg4)
{
    struct j_msat_callback_helper helper = {jenv, arg3};
    msat_env e;
    msat_term t;
    int retval;
  
    e.repr = (void *)((size_t)arg1);
    t.repr = (void *)((size_t)arg2);

    retval = msat_visit_term(e, t, call_java_visit_callback, &helper);

    return retval;
}


JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1apply_1substitution
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jint arg3, jlongArray arg4, jlongArray arg5)
{
  msat_env arg1_e;
  msat_term arg2_t;
  size_t arg3_n;
  msat_term * arg4_to_subst;
  msat_term * arg5_values;
  msat_term msat_apply_substitution_retval;
  jlong msat_apply_substitution_jretval;
  
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
arg3_n = arg3;
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg4, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg4));
  arg4_to_subst = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg4_to_subst[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg4, tmp, 0);
}

{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg5, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg5));
  arg5_values = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg5_values[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg5, tmp, 0);
}


  msat_apply_substitution_retval = msat_apply_substitution(arg1_e, arg2_t, arg3_n, arg4_to_subst, arg5_values);

  msat_apply_substitution_jretval = (jlong)((size_t)(msat_apply_substitution_retval.repr));
free(arg5_values);
free(arg4_to_subst);

  return msat_apply_substitution_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1find_1decl
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_symbol;
  msat_decl msat_find_decl_retval;
  jlong msat_find_decl_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_symbol = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);

  msat_find_decl_retval = msat_find_decl(arg1_e, arg2_symbol);

  msat_find_decl_jretval = (jlong)((size_t)(msat_find_decl_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_symbol);

  return msat_find_decl_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1term_1get_1decl
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  msat_decl msat_term_get_decl_retval;
  jlong msat_term_get_decl_jretval;
  

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_get_decl_retval = msat_term_get_decl(arg1_t);

  msat_term_get_decl_jretval = (jlong)((size_t)(msat_term_get_decl_retval.repr));

  return msat_term_get_decl_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1decl_1id
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  size_t msat_decl_id_retval;
  jint msat_decl_id_jretval;
  

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_id_retval = msat_decl_id(arg1_d);

  msat_decl_id_jretval = (jint)msat_decl_id_retval;

  return msat_decl_id_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1decl_1get_1tag
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_decl arg2_d;
  msat_symbol_tag msat_decl_get_tag_retval;
  jint msat_decl_get_tag_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_d.repr = (void *)((size_t)arg2);

  msat_decl_get_tag_retval = msat_decl_get_tag(arg1_e, arg2_d);

  msat_decl_get_tag_jretval = (jint)msat_decl_get_tag_retval;

  return msat_decl_get_tag_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1decl_1get_1return_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  msat_type msat_decl_get_return_type_retval;
  jlong msat_decl_get_return_type_jretval;
  

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_get_return_type_retval = msat_decl_get_return_type(arg1_d);

  msat_decl_get_return_type_jretval = (jlong)((size_t)(msat_decl_get_return_type_retval.repr));

  return msat_decl_get_return_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1decl_1get_1arity
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  size_t msat_decl_get_arity_retval;
  jint msat_decl_get_arity_jretval;
  

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_get_arity_retval = msat_decl_get_arity(arg1_d);

  msat_decl_get_arity_jretval = (jint)msat_decl_get_arity_retval;

  return msat_decl_get_arity_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1decl_1get_1arg_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_decl arg1_d;
  size_t arg2_n;
  msat_type msat_decl_get_arg_type_retval;
  jlong msat_decl_get_arg_type_jretval;
  
  

arg1_d.repr = (void *)((size_t)arg1);
arg2_n = arg2;

  msat_decl_get_arg_type_retval = msat_decl_get_arg_type(arg1_d, arg2_n);

  msat_decl_get_arg_type_jretval = (jlong)((size_t)(msat_decl_get_arg_type_retval.repr));

  return msat_decl_get_arg_type_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1decl_1get_1name
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  char * msat_decl_get_name_retval;
  jstring msat_decl_get_name_jretval;
  

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_get_name_retval = msat_decl_get_name(arg1_d);

  msat_decl_get_name_jretval = (*jenv)->NewStringUTF(jenv, msat_decl_get_name_retval);

  return msat_decl_get_name_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1decl_1repr
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  char * msat_decl_repr_retval;
  jstring msat_decl_repr_jretval;
  

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_repr_retval = msat_decl_repr(arg1_d);

  msat_decl_repr_jretval = (*jenv)->NewStringUTF(jenv, msat_decl_repr_retval);

  return msat_decl_repr_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1term_1repr
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  char * msat_term_repr_retval;
  jstring msat_term_repr_jretval;
  

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_repr_retval = msat_term_repr(arg1_t);

  msat_term_repr_jretval = (*jenv)->NewStringUTF(jenv, msat_term_repr_retval);

  return msat_term_repr_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1string
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_data;
  msat_term msat_from_string_retval;
  jlong msat_from_string_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);

  msat_from_string_retval = msat_from_string(arg1_e, arg2_data);

  msat_from_string_jretval = (jlong)((size_t)(msat_from_string_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_from_string_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1smtlib1
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_data;
  msat_term msat_from_smtlib1_retval;
  jlong msat_from_smtlib1_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);

  msat_from_smtlib1_retval = msat_from_smtlib1(arg1_e, arg2_data);

  msat_from_smtlib1_jretval = (jlong)((size_t)(msat_from_smtlib1_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_from_smtlib1_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1smtlib2
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_data;
  msat_term msat_from_smtlib2_retval;
  jlong msat_from_smtlib2_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);

  msat_from_smtlib2_retval = msat_from_smtlib2(arg1_e, arg2_data);

  msat_from_smtlib2_jretval = (jlong)((size_t)(msat_from_smtlib2_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_from_smtlib2_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1to_1smtlib1
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_term;
  char * msat_to_smtlib1_retval;
  jstring msat_to_smtlib1_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);

  msat_to_smtlib1_retval = msat_to_smtlib1(arg1_e, arg2_term);

  msat_to_smtlib1_jretval = (*jenv)->NewStringUTF(jenv, msat_to_smtlib1_retval);

  return msat_to_smtlib1_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1to_1smtlib2
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_term;
  char * msat_to_smtlib2_retval;
  jstring msat_to_smtlib2_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);

  msat_to_smtlib2_retval = msat_to_smtlib2(arg1_e, arg2_term);

  msat_to_smtlib2_jretval = (*jenv)->NewStringUTF(jenv, msat_to_smtlib2_retval);

  return msat_to_smtlib2_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1to_1smtlib2_1ext
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jstring arg3, jint arg4)
{
  msat_env arg1_e;
  msat_term arg2_term;
  char * arg3_logic_name;
  int arg4_use_defines;
  char * msat_to_smtlib2_ext_retval;
  jstring msat_to_smtlib2_ext_jretval;
  
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);
arg3_logic_name = (char *)(*jenv)->GetStringUTFChars(jenv, arg3, NULL);
arg4_use_defines = arg4;

  msat_to_smtlib2_ext_retval = msat_to_smtlib2_ext(arg1_e, arg2_term, arg3_logic_name, arg4_use_defines);

  msat_to_smtlib2_ext_jretval = (*jenv)->NewStringUTF(jenv, msat_to_smtlib2_ext_retval);
(*jenv)->ReleaseStringUTFChars(jenv, arg3, arg3_logic_name);

  return msat_to_smtlib2_ext_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1to_1smtlib2_1term
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_term;
  char * msat_to_smtlib2_term_retval;
  jstring msat_to_smtlib2_term_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);

  msat_to_smtlib2_term_retval = msat_to_smtlib2_term(arg1_e, arg2_term);

  msat_to_smtlib2_term_jretval = (*jenv)->NewStringUTF(jenv, msat_to_smtlib2_term_retval);

  return msat_to_smtlib2_term_jretval;

}

JNIEXPORT jobjectArray JNICALL Java_mathsat_api_msat_1named_1list_1from_1smtlib2
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jint arg3, jint arg4, jint arg5)
{
  msat_env arg1_e;
  char * arg2_data;
  size_t * arg3_out_n;
  char *** arg4_out_names;
  msat_term ** arg5_out_terms;
  int msat_named_list_from_smtlib2_retval;
  jobjectArray msat_named_list_from_smtlib2_jretval;
  
  
  size_t sz_tmp;
  char **out_names_tmp;
  msat_term *out_terms_tmp;

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
/*size_t*/ sz_tmp = 0;
arg3_out_n = &sz_tmp;

/*char **out_names_tmp = NULL;*/
out_names_tmp = NULL;
arg4_out_names = &out_names_tmp;

/*msat_term *out_terms_tmp = NULL;*/
out_terms_tmp = NULL;
arg5_out_terms = &out_terms_tmp;


  msat_named_list_from_smtlib2_retval = msat_named_list_from_smtlib2(arg1_e, arg2_data, arg3_out_n, arg4_out_names, arg5_out_terms);

  msat_named_list_from_smtlib2_jretval = (*jenv)->NewObjectArray(jenv, 2, (*jenv)->FindClass(jenv, "java/lang/Object"), 0);
if (msat_named_list_from_smtlib2_retval == 0) {
    jobjectArray jnames, jterms;
    size_t i;
    jlong *jarr;
    jnames = (*jenv)->NewObjectArray(jenv, sz_tmp, (*jenv)->FindClass(jenv, "java/lang/String"), (*jenv)->NewStringUTF(jenv, ""));
    for (i = 0; i < sz_tmp; ++i) {
        (*jenv)->SetObjectArrayElement(jenv, jnames, i, (*jenv)->NewStringUTF(jenv, out_names_tmp[i]));
    }
    jarr = malloc(sizeof(jlong) * sz_tmp);
    jterms = (*jenv)->NewLongArray(jenv, sz_tmp);
    for (i = 0; i < sz_tmp; ++i) {
        jarr[i] = (jlong)((size_t)out_terms_tmp[i].repr);
    }
    (*jenv)->SetLongArrayRegion(jenv, jterms, 0, sz_tmp, jarr);
    free(jarr);

    (*jenv)->SetObjectArrayElement(jenv, msat_named_list_from_smtlib2_jretval, 0, jnames);
    (*jenv)->SetObjectArrayElement(jenv, msat_named_list_from_smtlib2_jretval, 1, jterms);
}

if (out_terms_tmp) { msat_free(out_terms_tmp); }
if (out_names_tmp) { msat_free(out_names_tmp); }
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_named_list_from_smtlib2_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1named_1list_1to_1smtlib2
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jobjectArray arg3, jlongArray arg4)
{
  msat_env arg1_e;
  size_t arg2_n;
  char ** arg3_names;
  msat_term * arg4_terms;
  char * msat_named_list_to_smtlib2_retval;
  jstring msat_named_list_to_smtlib2_jretval;
  
  
  size_t i; size_t sz_names;
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_n = arg2;
/*size_t i;    */
/*size_t*/ sz_names = (*jenv)->GetArrayLength(jenv, arg3);
arg3_names = malloc(sizeof(const char *) * sz_names);
for (i = 0; i < sz_names; ++i) {
    jobject jo = (*jenv)->GetObjectArrayElement(jenv, arg3, i);
    jstring js = (jstring)jo;
    char *s = (char *)(*jenv)->GetStringUTFChars(jenv, js, NULL);
    char *s2 = malloc(strlen(s) + 1);
    strcpy(s2, s);
    (arg3_names)[i] = s2;
    (*jenv)->ReleaseStringUTFChars(jenv, js, s);
}

{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg4, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg4));
  arg4_terms = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg4_terms[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg4, tmp, 0);
}


  msat_named_list_to_smtlib2_retval = msat_named_list_to_smtlib2(arg1_e, arg2_n, arg3_names, arg4_terms);

  msat_named_list_to_smtlib2_jretval = (*jenv)->NewStringUTF(jenv, msat_named_list_to_smtlib2_retval);
free(arg4_terms);
for (i = 0; i < sz_names; ++i) {
    free((arg3_names)[i]);
}
free(arg3_names);


  return msat_named_list_to_smtlib2_jretval;

}

JNIEXPORT jobjectArray JNICALL Java_mathsat_api_msat_1annotated_1list_1from_1smtlib2
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jint arg3, jint arg4, jint arg5)
{
  msat_env arg1_e;
  char * arg2_data;
  size_t * arg3_out_n;
  msat_term ** arg4_out_terms;
  char *** arg5_out_annots;
  int msat_annotated_list_from_smtlib2_retval;
  jobjectArray msat_annotated_list_from_smtlib2_jretval;
  
  
  size_t sz_tmp;
  msat_term *out_terms_tmp;
  char **out_names_tmp;

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
/*size_t*/ sz_tmp = 0;
arg3_out_n = &sz_tmp;

/*msat_term *out_terms_tmp = NULL;*/
out_terms_tmp = NULL;
arg4_out_terms = &out_terms_tmp;

/*char **out_names_tmp = NULL;*/
out_names_tmp = NULL;
arg5_out_annots = &out_names_tmp;


  msat_annotated_list_from_smtlib2_retval = msat_annotated_list_from_smtlib2(arg1_e, arg2_data, arg3_out_n, arg4_out_terms, arg5_out_annots);

  msat_annotated_list_from_smtlib2_jretval = (*jenv)->NewObjectArray(jenv, 2, (*jenv)->FindClass(jenv, "java/lang/Object"), 0);
if (msat_annotated_list_from_smtlib2_retval == 0) {
    jobjectArray jterms, jannots;
    size_t i;
    jlong *jarr;
    jannots = (*jenv)->NewObjectArray(jenv, sz_tmp * 2, (*jenv)->FindClass(jenv, "java/lang/String"), (*jenv)->NewStringUTF(jenv, ""));
    for (i = 0; i < sz_tmp * 2; ++i) {
        (*jenv)->SetObjectArrayElement(jenv, jannots, i, (*jenv)->NewStringUTF(jenv, out_names_tmp[i]));
    }
    jarr = malloc(sizeof(jlong) * sz_tmp);
    jterms = (*jenv)->NewLongArray(jenv, sz_tmp);
    for (i = 0; i < sz_tmp; ++i) {
        jarr[i] = (jlong)((size_t)out_terms_tmp[i].repr);
    }
    (*jenv)->SetLongArrayRegion(jenv, jterms, 0, sz_tmp, jarr);
    free(jarr);

    (*jenv)->SetObjectArrayElement(jenv, msat_annotated_list_from_smtlib2_jretval, 0, jterms);
    (*jenv)->SetObjectArrayElement(jenv, msat_annotated_list_from_smtlib2_jretval, 1, jannots);
}

if (out_names_tmp) { msat_free(out_names_tmp); }
if (out_terms_tmp) { msat_free(out_terms_tmp); }
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_annotated_list_from_smtlib2_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1annotated_1list_1to_1smtlib2
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlongArray arg3, jobjectArray arg4)
{
  msat_env arg1_e;
  size_t arg2_n;
  msat_term * arg3_terms;
  char ** arg4_annots;
  char * msat_annotated_list_to_smtlib2_retval;
  jstring msat_annotated_list_to_smtlib2_jretval;
  
  
  
  size_t i; size_t sz_names;

arg1_e.repr = (void *)((size_t)arg1);
arg2_n = arg2;
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg3, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg3));
  arg3_terms = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg3_terms[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg3, tmp, 0);
}

/*size_t i;    */
/*size_t*/ sz_names = (*jenv)->GetArrayLength(jenv, arg4);
arg4_annots = malloc(sizeof(const char *) * sz_names);
for (i = 0; i < sz_names; ++i) {
    jobject jo = (*jenv)->GetObjectArrayElement(jenv, arg4, i);
    jstring js = (jstring)jo;
    char *s = (char *)(*jenv)->GetStringUTFChars(jenv, js, NULL);
    char *s2 = malloc(strlen(s) + 1);
    strcpy(s2, s);
    (arg4_annots)[i] = s2;
    (*jenv)->ReleaseStringUTFChars(jenv, js, s);
}


  msat_annotated_list_to_smtlib2_retval = msat_annotated_list_to_smtlib2(arg1_e, arg2_n, arg3_terms, arg4_annots);

  msat_annotated_list_to_smtlib2_jretval = (*jenv)->NewStringUTF(jenv, msat_annotated_list_to_smtlib2_retval);
for (i = 0; i < sz_names; ++i) {
    free((arg4_annots)[i]);
}
free(arg4_annots);

free(arg3_terms);

  return msat_annotated_list_to_smtlib2_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1push_1backtrack_1point
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_push_backtrack_point_retval;
  jint msat_push_backtrack_point_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_push_backtrack_point_retval = msat_push_backtrack_point(arg1_e);

  msat_push_backtrack_point_jretval = (jint)msat_push_backtrack_point_retval;

  return msat_push_backtrack_point_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1pop_1backtrack_1point
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_pop_backtrack_point_retval;
  jint msat_pop_backtrack_point_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_pop_backtrack_point_retval = msat_pop_backtrack_point(arg1_e);

  msat_pop_backtrack_point_jretval = (jint)msat_pop_backtrack_point_retval;

  return msat_pop_backtrack_point_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1num_1backtrack_1points
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  size_t msat_num_backtrack_points_retval;
  jint msat_num_backtrack_points_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_num_backtrack_points_retval = msat_num_backtrack_points(arg1_e);

  msat_num_backtrack_points_jretval = (jint)msat_num_backtrack_points_retval;

  return msat_num_backtrack_points_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1reset_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_reset_env_retval;
  jint msat_reset_env_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_reset_env_retval = msat_reset_env(arg1_e);

  msat_reset_env_jretval = (jint)msat_reset_env_retval;

  return msat_reset_env_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1assert_1formula
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_formula;
  int msat_assert_formula_retval;
  jint msat_assert_formula_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);

  msat_assert_formula_retval = msat_assert_formula(arg1_e, arg2_formula);

  msat_assert_formula_jretval = (jint)msat_assert_formula_retval;

  return msat_assert_formula_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1add_1preferred_1for_1branching
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jint arg3)
{
  msat_env arg1_e;
  msat_term arg2_boolvar;
  msat_truth_value arg3_phase;
  int msat_add_preferred_for_branching_retval;
  jint msat_add_preferred_for_branching_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_boolvar.repr = (void *)((size_t)arg2);
arg3_phase = arg3;

  msat_add_preferred_for_branching_retval = msat_add_preferred_for_branching(arg1_e, arg2_boolvar, arg3_phase);

  msat_add_preferred_for_branching_jretval = (jint)msat_add_preferred_for_branching_retval;

  return msat_add_preferred_for_branching_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1clear_1preferred_1for_1branching
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_clear_preferred_for_branching_retval;
  jint msat_clear_preferred_for_branching_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_clear_preferred_for_branching_retval = msat_clear_preferred_for_branching(arg1_e);

  msat_clear_preferred_for_branching_jretval = (jint)msat_clear_preferred_for_branching_retval;

  return msat_clear_preferred_for_branching_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1solve
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_result msat_solve_retval;
  jint msat_solve_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_solve_retval = msat_solve(arg1_e);

  msat_solve_jretval = (jint)msat_solve_retval;

  return msat_solve_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1solve_1with_1assumptions
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jint arg3)
{
  msat_env arg1_e;
  msat_term * arg2_assumptions;
  size_t arg3_num_assumptions;
  msat_result msat_solve_with_assumptions_retval;
  jint msat_solve_with_assumptions_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg2, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg2));
  arg2_assumptions = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg2_assumptions[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg2, tmp, 0);
}

arg3_num_assumptions = arg3;

  msat_solve_with_assumptions_retval = msat_solve_with_assumptions(arg1_e, arg2_assumptions, arg3_num_assumptions);

  msat_solve_with_assumptions_jretval = (jint)msat_solve_with_assumptions_retval;
free(arg2_assumptions);

  return msat_solve_with_assumptions_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1all_1sat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jint arg3,
   jobject arg4, jint arg5)
{
    struct j_msat_callback_helper helper = {jenv, arg4};
    msat_env e;
    msat_term *important;
    int retval;
    int i;
    int len;
    jlong *larr;
  
    e.repr = (void *)((size_t)arg1);
    len = (int)(*jenv)->GetArrayLength(jenv, arg2);
    important = malloc(sizeof(msat_term) * len);

    larr = (*jenv)->GetLongArrayElements(jenv, arg2, NULL);
    for (i = 0; i < len; ++i) {
        important[i].repr = (void *)((size_t)larr[i]);
    }
    (*jenv)->ReleaseLongArrayElements(jenv, arg2, larr, 0);

    retval = msat_all_sat(e, important, len, call_java_allsat_callback,
                          &helper);

    free(important);

    return retval;
}


JNIEXPORT jint JNICALL Java_mathsat_api_msat_1solve_1diversify
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2,
  jint arg3, jobject arg4, jint arg5)
{
    struct j_msat_callback_helper helper = {jenv, arg4};
    msat_env e;
    msat_term *diversifiers;
    int retval;
    int i;
    int len;
    jlong *larr;
  
    e.repr = (void *)((size_t)arg1);
    len = (int)(*jenv)->GetArrayLength(jenv, arg2);
    diversifiers = malloc(sizeof(msat_term) * len);

    larr = (*jenv)->GetLongArrayElements(jenv, arg2, NULL);
    for (i = 0; i < len; ++i) {
        diversifiers[i].repr = (void *)((size_t)larr[i]);
    }
    (*jenv)->ReleaseLongArrayElements(jenv, arg2, larr, 0);

    retval = msat_solve_diversify(e, diversifiers, len,
                                  call_java_solve_diversify_callback, &helper);

    free(diversifiers);

    return retval;
}


JNIEXPORT jlongArray JNICALL Java_mathsat_api_msat_1get_1asserted_1formulas
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  size_t * arg2_num_asserted;
  msat_term * msat_get_asserted_formulas_retval;
  jlongArray msat_get_asserted_formulas_jretval;
  
  size_t sz_tmp;

arg1_e.repr = (void *)((size_t)arg1);
/*size_t*/ sz_tmp = 0;
arg2_num_asserted = &sz_tmp;


  msat_get_asserted_formulas_retval = msat_get_asserted_formulas(arg1_e, arg2_num_asserted);

  if (sz_tmp > 0) {
  msat_get_asserted_formulas_jretval = (*jenv)->NewLongArray(jenv, sz_tmp);
  {
    jlong *jarr = malloc(sizeof(jlong) * sz_tmp);
    int i;
    for (i = 0; i < sz_tmp; ++i) {
        jarr[i] = (jlong)((size_t)msat_get_asserted_formulas_retval[i].repr);
    }
    (*jenv)->SetLongArrayRegion(jenv, msat_get_asserted_formulas_jretval, 0, sz_tmp, jarr);
    free(jarr);
  }
} else {
  msat_get_asserted_formulas_jretval = (*jenv)->NewLongArray(jenv, 0);
}
if (msat_get_asserted_formulas_retval) {
    free(msat_get_asserted_formulas_retval);
}    


  return msat_get_asserted_formulas_jretval;

}

JNIEXPORT jlongArray JNICALL Java_mathsat_api_msat_1get_1theory_1lemmas
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  size_t * arg2_num_tlemmas;
  msat_term * msat_get_theory_lemmas_retval;
  jlongArray msat_get_theory_lemmas_jretval;
  
  size_t sz_tmp;

arg1_e.repr = (void *)((size_t)arg1);
/*size_t*/ sz_tmp = 0;
arg2_num_tlemmas = &sz_tmp;


  msat_get_theory_lemmas_retval = msat_get_theory_lemmas(arg1_e, arg2_num_tlemmas);

  if (sz_tmp > 0) {
  msat_get_theory_lemmas_jretval = (*jenv)->NewLongArray(jenv, sz_tmp);
  {
    jlong *jarr = malloc(sizeof(jlong) * sz_tmp);
    int i;
    for (i = 0; i < sz_tmp; ++i) {
        jarr[i] = (jlong)((size_t)msat_get_theory_lemmas_retval[i].repr);
    }
    (*jenv)->SetLongArrayRegion(jenv, msat_get_theory_lemmas_jretval, 0, sz_tmp, jarr);
    free(jarr);
  }
} else {
  msat_get_theory_lemmas_jretval = (*jenv)->NewLongArray(jenv, 0);
}
if (msat_get_theory_lemmas_retval) {
    free(msat_get_theory_lemmas_retval);
}    


  return msat_get_theory_lemmas_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1get_1search_1stats
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  char * msat_get_search_stats_retval;
  jstring msat_get_search_stats_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_get_search_stats_retval = msat_get_search_stats(arg1_e);

  msat_get_search_stats_jretval = (*jenv)->NewStringUTF(jenv, msat_get_search_stats_retval);

  return msat_get_search_stats_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1create_1itp_1group
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_create_itp_group_retval;
  jint msat_create_itp_group_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_create_itp_group_retval = msat_create_itp_group(arg1_e);

  msat_create_itp_group_jretval = (jint)msat_create_itp_group_retval;

  return msat_create_itp_group_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1set_1itp_1group
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  int arg2_group;
  int msat_set_itp_group_retval;
  jint msat_set_itp_group_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_group = arg2;

  msat_set_itp_group_retval = msat_set_itp_group(arg1_e, arg2_group);

  msat_set_itp_group_jretval = (jint)msat_set_itp_group_retval;

  return msat_set_itp_group_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1interpolant
  (JNIEnv *jenv, jclass jcls, jlong arg1, jintArray arg2, jint arg3)
{
  msat_env arg1_e;
  int * arg2_groups_of_a;
  size_t arg3_n;
  msat_term msat_get_interpolant_retval;
  jlong msat_get_interpolant_jretval;
  
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_groups_of_a = (int *)((*jenv)->GetIntArrayElements(jenv, arg2, NULL));

arg3_n = arg3;

  msat_get_interpolant_retval = msat_get_interpolant(arg1_e, arg2_groups_of_a, arg3_n);

  msat_get_interpolant_jretval = (jlong)((size_t)(msat_get_interpolant_retval.repr));
(*jenv)->ReleaseIntArrayElements(jenv, arg2, arg2_groups_of_a, 0);


  return msat_get_interpolant_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1model_1value
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_term;
  msat_term msat_get_model_value_retval;
  jlong msat_get_model_value_jretval;
  
  

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);

  msat_get_model_value_retval = msat_get_model_value(arg1_e, arg2_term);

  msat_get_model_value_jretval = (jlong)((size_t)(msat_get_model_value_retval.repr));

  return msat_get_model_value_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1model_1iterator
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_model_iterator msat_create_model_iterator_retval;
  jlong msat_create_model_iterator_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_create_model_iterator_retval = msat_create_model_iterator(arg1_e);

  msat_create_model_iterator_jretval = (jlong)((size_t)(msat_create_model_iterator_retval.repr));

  return msat_create_model_iterator_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1model_1iterator_1has_1next
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_model_iterator arg1_i;
  int msat_model_iterator_has_next_retval;
  jint msat_model_iterator_has_next_jretval;
  

arg1_i.repr = (void *)((size_t)arg1);

  msat_model_iterator_has_next_retval = msat_model_iterator_has_next(arg1_i);

  msat_model_iterator_has_next_jretval = (jint)msat_model_iterator_has_next_retval;

  return msat_model_iterator_has_next_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1model_1iterator_1next
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jlongArray arg3)
{
  msat_model_iterator arg1_i;
  msat_term * arg2_t;
  msat_term * arg3_v;
  int msat_model_iterator_next_retval;
  jint msat_model_iterator_next_jretval;
  
  msat_term ptrarg2_t;
  msat_term ptrarg3_v;

arg1_i.repr = (void *)((size_t)arg1);
/*msat_term ptrarg2_t;*/
arg2_t = &ptrarg2_t;

/*msat_term ptrarg3_v;*/
arg3_v = &ptrarg3_v;


  msat_model_iterator_next_retval = msat_model_iterator_next(arg1_i, arg2_t, arg3_v);

  msat_model_iterator_next_jretval = (jint)msat_model_iterator_next_retval;
(*jenv)->SetLongArrayRegion(jenv, arg3, 0, 1, (jlong *)&(ptrarg3_v.repr));

(*jenv)->SetLongArrayRegion(jenv, arg2, 0, 1, (jlong *)&(ptrarg2_t.repr));


  return msat_model_iterator_next_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1model_1iterator
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_model_iterator arg1_i;
  

arg1_i.repr = (void *)((size_t)arg1);

  msat_destroy_model_iterator(arg1_i);

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1model
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_model msat_get_model_retval;
  jlong msat_get_model_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_get_model_retval = msat_get_model(arg1_e);

  msat_get_model_jretval = (jlong)((size_t)(msat_get_model_retval.repr));

  return msat_get_model_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1model
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_model arg1_m;
  

arg1_m.repr = (void *)((size_t)arg1);

  msat_destroy_model(arg1_m);

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1model_1eval
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_model arg1_m;
  msat_term arg2_t;
  msat_term msat_model_eval_retval;
  jlong msat_model_eval_jretval;
  
  

arg1_m.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_model_eval_retval = msat_model_eval(arg1_m, arg2_t);

  msat_model_eval_jretval = (jlong)((size_t)(msat_model_eval_retval.repr));

  return msat_model_eval_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1model_1create_1iterator
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_model arg1_m;
  msat_model_iterator msat_model_create_iterator_retval;
  jlong msat_model_create_iterator_jretval;
  

arg1_m.repr = (void *)((size_t)arg1);

  msat_model_create_iterator_retval = msat_model_create_iterator(arg1_m);

  msat_model_create_iterator_jretval = (jlong)((size_t)(msat_model_create_iterator_retval.repr));

  return msat_model_create_iterator_jretval;

}

JNIEXPORT jlongArray JNICALL Java_mathsat_api_msat_1get_1unsat_1core
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  size_t * arg2_core_size;
  msat_term * msat_get_unsat_core_retval;
  jlongArray msat_get_unsat_core_jretval;
  
  size_t sz_tmp;

arg1_e.repr = (void *)((size_t)arg1);
/*size_t*/ sz_tmp = 0;
arg2_core_size = &sz_tmp;


  msat_get_unsat_core_retval = msat_get_unsat_core(arg1_e, arg2_core_size);

  if (sz_tmp > 0) {
  msat_get_unsat_core_jretval = (*jenv)->NewLongArray(jenv, sz_tmp);
  {
    jlong *jarr = malloc(sizeof(jlong) * sz_tmp);
    int i;
    for (i = 0; i < sz_tmp; ++i) {
        jarr[i] = (jlong)((size_t)msat_get_unsat_core_retval[i].repr);
    }
    (*jenv)->SetLongArrayRegion(jenv, msat_get_unsat_core_jretval, 0, sz_tmp, jarr);
    free(jarr);
  }
} else {
  msat_get_unsat_core_jretval = (*jenv)->NewLongArray(jenv, 0);
}
if (msat_get_unsat_core_retval) {
    free(msat_get_unsat_core_retval);
}    


  return msat_get_unsat_core_jretval;

}

JNIEXPORT jlongArray JNICALL Java_mathsat_api_msat_1get_1unsat_1assumptions
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  size_t * arg2_assumps_size;
  msat_term * msat_get_unsat_assumptions_retval;
  jlongArray msat_get_unsat_assumptions_jretval;
  
  size_t sz_tmp;

arg1_e.repr = (void *)((size_t)arg1);
/*size_t*/ sz_tmp = 0;
arg2_assumps_size = &sz_tmp;


  msat_get_unsat_assumptions_retval = msat_get_unsat_assumptions(arg1_e, arg2_assumps_size);

  if (sz_tmp > 0) {
  msat_get_unsat_assumptions_jretval = (*jenv)->NewLongArray(jenv, sz_tmp);
  {
    jlong *jarr = malloc(sizeof(jlong) * sz_tmp);
    int i;
    for (i = 0; i < sz_tmp; ++i) {
        jarr[i] = (jlong)((size_t)msat_get_unsat_assumptions_retval[i].repr);
    }
    (*jenv)->SetLongArrayRegion(jenv, msat_get_unsat_assumptions_jretval, 0, sz_tmp, jarr);
    free(jarr);
  }
} else {
  msat_get_unsat_assumptions_jretval = (*jenv)->NewLongArray(jenv, 0);
}
if (msat_get_unsat_assumptions_retval) {
    free(msat_get_unsat_assumptions_retval);
}    


  return msat_get_unsat_assumptions_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1proof_1manager
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_proof_manager msat_get_proof_manager_retval;
  jlong msat_get_proof_manager_jretval;
  

arg1_e.repr = (void *)((size_t)arg1);

  msat_get_proof_manager_retval = msat_get_proof_manager(arg1_e);

  msat_get_proof_manager_jretval = (jlong)((size_t)(msat_get_proof_manager_retval.repr));

  return msat_get_proof_manager_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1proof_1manager
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_proof_manager arg1_m;
  

arg1_m.repr = (void *)((size_t)arg1);

  msat_destroy_proof_manager(arg1_m);

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1proof
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_proof_manager arg1_m;
  msat_proof msat_get_proof_retval;
  jlong msat_get_proof_jretval;
  

arg1_m.repr = (void *)((size_t)arg1);

  msat_get_proof_retval = msat_get_proof(arg1_m);

  msat_get_proof_jretval = (jlong)((size_t)(msat_get_proof_retval.repr));

  return msat_get_proof_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1proof_1id
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_proof arg1_p;
  size_t msat_proof_id_retval;
  jint msat_proof_id_jretval;
  

arg1_p.repr = (void *)((size_t)arg1);

  msat_proof_id_retval = msat_proof_id(arg1_p);

  msat_proof_id_jretval = (jint)msat_proof_id_retval;

  return msat_proof_id_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1proof_1is_1term
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_proof arg1_p;
  int msat_proof_is_term_retval;
  jint msat_proof_is_term_jretval;
  

arg1_p.repr = (void *)((size_t)arg1);

  msat_proof_is_term_retval = msat_proof_is_term(arg1_p);

  msat_proof_is_term_jretval = (jint)msat_proof_is_term_retval;

  return msat_proof_is_term_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1proof_1get_1term
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_proof arg1_p;
  msat_term msat_proof_get_term_retval;
  jlong msat_proof_get_term_jretval;
  

arg1_p.repr = (void *)((size_t)arg1);

  msat_proof_get_term_retval = msat_proof_get_term(arg1_p);

  msat_proof_get_term_jretval = (jlong)((size_t)(msat_proof_get_term_retval.repr));

  return msat_proof_get_term_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1proof_1get_1name
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_proof arg1_p;
  const char * msat_proof_get_name_retval;
  jstring msat_proof_get_name_jretval;
  

arg1_p.repr = (void *)((size_t)arg1);

  msat_proof_get_name_retval = msat_proof_get_name(arg1_p);

  msat_proof_get_name_jretval = (*jenv)->NewStringUTF(jenv, msat_proof_get_name_retval);

  return msat_proof_get_name_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1proof_1get_1arity
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_proof arg1_p;
  size_t msat_proof_get_arity_retval;
  jint msat_proof_get_arity_jretval;
  

arg1_p.repr = (void *)((size_t)arg1);

  msat_proof_get_arity_retval = msat_proof_get_arity(arg1_p);

  msat_proof_get_arity_jretval = (jint)msat_proof_get_arity_retval;

  return msat_proof_get_arity_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1proof_1get_1child
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_proof arg1_p;
  size_t arg2_i;
  msat_proof msat_proof_get_child_retval;
  jlong msat_proof_get_child_jretval;
  
  

arg1_p.repr = (void *)((size_t)arg1);
arg2_i = arg2;

  msat_proof_get_child_retval = msat_proof_get_child(arg1_p, arg2_i);

  msat_proof_get_child_jretval = (jlong)((size_t)(msat_proof_get_child_retval.repr));

  return msat_proof_get_child_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1exist_1elim
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3, jint arg4, jint arg5, jintArray arg6)
{
  msat_env arg1_env;
  msat_term arg2_formula;
  msat_term * arg3_vars_to_elim;
  size_t arg4_num_vars_to_elim;
  msat_exist_elim_algorithm arg5_algo;
  msat_exist_elim_options arg6_options;
  msat_term msat_exist_elim_retval;
  jlong msat_exist_elim_jretval;
  
  
  
  
  
  int *opts_arr;

arg1_env.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg3, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg3));
  arg3_vars_to_elim = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg3_vars_to_elim[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg3, tmp, 0);
}

arg4_num_vars_to_elim = arg4;
arg5_algo = arg5;
opts_arr = (int *)((*jenv)->GetIntArrayElements(jenv, arg6, NULL));
arg6_options.toplevel_propagation = opts_arr[0];
arg6_options.boolean_simplifications = opts_arr[1];
arg6_options.remove_redundant_constraints = opts_arr[2];


  msat_exist_elim_retval = msat_exist_elim(arg1_env, arg2_formula, arg3_vars_to_elim, arg4_num_vars_to_elim, arg5_algo, arg6_options);

  msat_exist_elim_jretval = (jlong)((size_t)(msat_exist_elim_retval.repr));
(*jenv)->ReleaseIntArrayElements(jenv, arg6, opts_arr, 0);
free(arg3_vars_to_elim);

  return msat_exist_elim_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1exist_1elim_1model
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3, jint arg4, jlongArray arg5, jlongArray arg6, jint arg7)
{
  msat_env arg1_env;
  msat_term arg2_formula;
  msat_term * arg3_vars_to_elim;
  size_t arg4_num_vars_to_elim;
  msat_term * arg5_model_vars;
  msat_term * arg6_model_values;
  size_t arg7_model_size;
  msat_term msat_exist_elim_model_retval;
  jlong msat_exist_elim_model_jretval;
  
  
  
  
  
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg3, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg3));
  arg3_vars_to_elim = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg3_vars_to_elim[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg3, tmp, 0);
}

arg4_num_vars_to_elim = arg4;
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg5, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg5));
  arg5_model_vars = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg5_model_vars[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg5, tmp, 0);
}

{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg6, NULL));
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg6));
  arg6_model_values = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg6_model_values[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg6, tmp, 0);
}

arg7_model_size = arg7;

  msat_exist_elim_model_retval = msat_exist_elim_model(arg1_env, arg2_formula, arg3_vars_to_elim, arg4_num_vars_to_elim, arg5_model_vars, arg6_model_values, arg7_model_size);

  msat_exist_elim_model_jretval = (jlong)((size_t)(msat_exist_elim_model_retval.repr));
free(arg6_model_values);
free(arg5_model_vars);
free(arg3_vars_to_elim);

  return msat_exist_elim_model_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1aig_1simplify
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_env;
  msat_term arg2_formula;
  msat_term msat_aig_simplify_retval;
  jlong msat_aig_simplify_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);

  msat_aig_simplify_retval = msat_aig_simplify(arg1_env, arg2_formula);

  msat_aig_simplify_jretval = (jlong)((size_t)(msat_aig_simplify_retval.repr));

  return msat_aig_simplify_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1to_1nnf
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_env;
  msat_term arg2_formula;
  msat_term msat_to_nnf_retval;
  jlong msat_to_nnf_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);

  msat_to_nnf_retval = msat_to_nnf(arg1_env, arg2_formula);

  msat_to_nnf_jretval = (jlong)((size_t)(msat_to_nnf_retval.repr));

  return msat_to_nnf_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1lra_1simplify
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_env;
  msat_term arg2_formula;
  msat_term msat_lra_simplify_retval;
  jlong msat_lra_simplify_jretval;
  
  

arg1_env.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);

  msat_lra_simplify_retval = msat_lra_simplify(arg1_env, arg2_formula);

  msat_lra_simplify_jretval = (jlong)((size_t)(msat_lra_simplify_retval.repr));

  return msat_lra_simplify_jretval;

}
